<?php

namespace icmain;

/**
 *
 * @link              https://www.infocaptor.com
 *
 * @wordpress-plugin
 * Plugin Name:       WooCommerce Reporting Pro - InfoCaptor
 * Plugin URI:        https://www.infocaptor.com/woocommerce-reports-and-dashboards
 * Description:       MAIN: Useful reports and dashboards for your WooCommerce. Sales KPI/Metrics, Product Metrics, Customer Metrics with drill downs and beautiful visualizations
 * Version:           1.7.6
 * Author:            InfoCaptor
 * Author URI:        https://www.infocaptor.com
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       dash-reports-woocommerce-ic
 * Domain Path:       /languages
 */

//AUM Ganapataye Namah
 //##INFOCAPTOR##

// If this file is called directly, abort.
if ( ! defined( 'ABSPATH' ) ) exit;


/**
 * Once upon a time... when it all started 
 */

defined('ICDASH_WOO_IC_VERSION') or define( 'ICDASH_WOO_IC_VERSION', '1.7.6' );


/**
 * who am I? 
 * replicated copy of constants from x.constants
 */
defined('ICDASH_LOGIN_STR') 		or define('ICDASH_LOGIN_STR',"xmember-getin-icdash".$_SERVER['HTTP_HOST']);
defined('ICDASH_LOGIN_TOKEN') 		or define('ICDASH_LOGIN_TOKEN',"icdash-".bin2hex(base64_encode(ICDASH_LOGIN_STR)));
defined('WPICDASH_STR') 			or define('WPICDASH_STR',"wpxmember-noin-icdash".$_SERVER['HTTP_HOST']);
defined('WPICDASH_TOKEN') 			or define('WPICDASH_TOKEN',"icdash-".bin2hex(base64_encode(WPICDASH_STR)));
defined('ICDASH_ADMIN_TOKEN') 		or define('ICDASH_ADMIN_TOKEN',"icdash-".bin2hex(base64_encode("ADMIN".WPICDASH_STR)));
defined('ICDASH_IS_ADMIN') 			or define('ICDASH_IS_ADMIN',"icdash-".bin2hex(base64_encode("YES_ADMIN".WPICDASH_STR)));
defined('ICDASH_IS_NO_USER') 		or define('ICDASH_IS_NO_USER',"icdash-".bin2hex(base64_encode("NO_USER".WPICDASH_STR)));
defined('ICDASH_IS_NO_ADMIN') 		or define('ICDASH_IS_NO_ADMIN',"icdash-".bin2hex(base64_encode("NO_ADMIN".WPICDASH_STR)));
defined('WPICDASH_AUTOUPDATE_URL') 	or define('WPICDASH_AUTOUPDATE_URL','https://my.infocaptor.com/plugins/pro_plugin_updates.php');
defined(__NAMESPACE__.'ICDASH_UPGRADE_CHECK') 	or define(__NAMESPACE__.'ICDASH_UPGRADE_CHECK','icdash_server_updates-'.__NAMESPACE__);
defined('ICDASH_DEBUG_MODE') 		or define('ICDASH_DEBUG_MODE','NO');
$icdash_phpglb=array();

$icdash_ns_options=array("namespace"=>"icmain","Name"=>"WooCommerce Reporting Pro - InfoCaptor","menu_name"=>"InfoCaptor Dashboards"
                                    ,"PluginURI"=>"https://www.infocaptor.com/woocommerce-reports-and-dashboards"
                                    ,"Description"=>"> Useful reports and dashboards for your WooCommerce. Sales KPI/Metrics, Product Metrics, Customer Metrics with drill downs and beautiful visualizations"
                                    ,"TextDomain" => "dash-reports-woocommerce-ic");
/**
 * options string for this plugin, this is also the menu slug. 
 * This needs to be the same if settings are on the same page as list of dashboards
*/
defined(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS') or define(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS','icdash-reports-woocommerce-'.__NAMESPACE__); 

$secure = ( 'https' === parse_url( wp_login_url(), PHP_URL_SCHEME ) );


//include plugin_dir_path( __FILE__ ) . 'reports/woocommerce/icdash_reporting_variants.php';

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-dash-reports-woocommerce-ic-activator.php
 */
function activate_dash_reports_woocommerce_ic() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-dash-reports-woocommerce-ic-activator.php';
	\Dash_Reports_Woocommerce_Ic_Activator::activate();
	
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-dash-reports-woocommerce-ic-deactivator.php
 */
function deactivate_dash_reports_woocommerce_ic() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-dash-reports-woocommerce-ic-deactivator.php';
	\Dash_Reports_Woocommerce_Ic_Deactivator::deactivate();
}

register_activation_hook( __FILE__, __NAMESPACE__.'\activate_dash_reports_woocommerce_ic' );
register_deactivation_hook( __FILE__, __NAMESPACE__.'\deactivate_dash_reports_woocommerce_ic' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */


//important actions
if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')))) 
{

	//bake the cookie
	icdash_set_cookies();

	//oh my own sweet home!
	add_action('admin_menu', __NAMESPACE__.'\icdash_woo_config_page');
	//add_action('init', 'icdash_woo_add_rewrite_rule'); //need to pass base url to the JS so as not to break css and js files
	
	// at logout Ta-Ta
	add_action( 'wp_logout', __NAMESPACE__.'\icdash_action_wp_logout');

	// keep it clean for the demo account
	add_action( 'admin_init', __NAMESPACE__.'\icdash_remove_menu_pages' );	
	
	//cron is defined here
	icdash_cron_activation();

	
}




/**
 * The code that adds the sub menu under the woocommerce
 * This also loads the needed javascript but only if the plugin's page is loaded. We don't want to load the javascript for all the plugins or the admin page
 */
function icdash_woo_config_page()
{
	global $icdash_ns_options;
	add_menu_page(
		__($icdash_ns_options["menu_name"]) ,
		__($icdash_ns_options["menu_name"]) ,
		'manage_woocommerce',
		constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS'),
		false,
		'dashicons-admin-generic',
		''
	);

	if(function_exists('add_submenu_page'))
	{

		/*
		 add_submenu_page( string $parent_slug
		, string $page_title 
		, string $menu_title
		 , string $capability   
		 , string $menu_slug
		  , callable $function = '' )*/
		$ic_admin_page=  add_submenu_page(
			constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS')
		, __($icdash_ns_options["Name"])
		, __($icdash_ns_options["menu_name"]) 
		, 'manage_woocommerce' 
		, constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS')
		, __NAMESPACE__.'\icdash_woo_conf');

		/*$ic_admin_page2=  add_submenu_page(
			constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS')
		, __($icdash_ns_options["Name"]." v2")
		, __($icdash_ns_options["menu_name"]." v2") 
		, 'manage_woocommerce' 
		, constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS')
		, __NAMESPACE__.'\icdash_woo_conf');	*/	
	   // $ic_admin_page=  add_submenu_page('woocommerce'       , __($icdash_ns_options["Name"]), __($icdash_ns_options["menu_name"]) , 'manage_woocommerce' , constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS'), __NAMESPACE__.'\icdash_woo_conf');		
		
		// Load the JS conditionally only for the woo admin page of infocaptor
        add_action( 'load-' . $ic_admin_page, __NAMESPACE__.'\icdash_woo_load_js' );		
		//add_action('admin_enqueue_scripts', __NAMESPACE__.'\icdash_woo_admin_scripts');
	}	
}

/**
 * The code that actually generates the settings and the list of dashboards. 
 * During activation this will ask the user to complete the install process and then once complete will display a list of activated dashboards
 */
function icdash_woo_conf()
{

global $icdash_phpglb;
global $icdash_ns_options;

    //check if previously installed
	$key = get_option('icdash_woo_key');
	if($key === false)
	{
		$key = "ICDASHYESINSTALLED";
		
		if(!update_option('icdash_woo_key', $key))
			exit;
	}	
	
	//check if admin user
	$is_admin_user=icdash_check_admin_user();
	$current_user = wp_get_current_user();
	 if (!in_array('administrator',  $current_user->roles))
	 {
		$icdash_phpglb["is_admin_role"]="N";
	 }
	 else $icdash_phpglb["is_admin_role"]="Y";

	
	$current_version=ICDASH_WOO_IC_VERSION;
	//check if all installation went fine
	$install_complete=get_option('icdash_woo_core_seedata');
	if($install_complete === false) $install_complete="N";
	else $install_complete="Y";
	$show_dashboard_list=" ";
	$update_html=" ";
	$icdash_phpglb["install_html"]=" ";
	$upgrade_script= " ";
	$update_details["mesg"]=" ";
	$install_start_button= " ";
	//collect some basic paths and urls
	$plugin_dir_path=plugin_dir_path( __FILE__ );
	$base_file= __FILE__;
	$plugin_dir=__DIR__;
	$dir_base=basename($plugin_dir);
	$plugin_base_url=plugins_url()."/".$dir_base;
    $button_style="font-size:28px;height:56px;";
	$content_dir_path = wp_normalize_path(WP_CONTENT_DIR);

if ($is_admin_user==ICDASH_IS_ADMIN)
{
	//build the install html

	if ($install_complete=="Y")
	{
		$button_style.="display:none;"; //we want the install button html always there just not show it everytime
	}


	$install_html=<<<EOD
	<button type="button" class="button-primary" style="{$button_style}" id="icdash_start_install"> Click to Complete Setup </button>
EOD;
	 
	 $icdash_phpglb["install_html"]=$install_html;	


	if ($install_complete=="N")
	{

		 $show_dashboard_list='style="display:none;"';

	}
	else 
	{
		$install_html=" ";
		$show_dashboard_list= " ";
		
		//check if new update available -- pass $plugin_dir_path,$plugin_slug
		$update_details=icdash_is_new_update($plugin_dir_path,$dir_base);
		if ($update_details["available"])
		{
			$update_html=<<<EOD
			<div>
				<hr>
			New version available : {$update_details["new_version"]}
			</div>
				<button type="button" class="button-primary" style="font-size:28px;height:56px;" id="icdash_start_upgrade"> Click to Upgrade Now </button>
				<hr>	
EOD;
			$icdash_phpglb["install_html"]=$update_html.$icdash_phpglb["install_html"];
			$upgrade_script="{$plugin_base_url}/infocaptor/woo_ic_upgrade.php?mode=PLUGN_UPGRADE&down_lnk={$update_details["package"]}&plugin_dir_base={$dir_base}&content_dir={$content_dir_path}";
		}
		else 
		{
			$icdash_phpglb["update_info"]=$update_details["mesg"];
			

		}
	}	
} //END IF ICDASH_IS_ADMIN	

    $my_file_ver  = date("ymd-Gis", filemtime(  __FILE__ )  );
	$install_url= $plugin_base_url."/infocaptor/woo_ic_install.php?mode=woo_manual_install";

    $list_of_dashboards=icdash_woo_get_dashboard_list($plugin_dir,$plugin_base_url);
	$ABSPATH=ABSPATH;
	$SITECOOKIEPATH=SITECOOKIEPATH;
	
	$debug_html=" ";
	$register_html=" ";
	
	if (ICDASH_DEBUG_MODE=="YES" &&($is_admin_user==ICDASH_IS_ADMIN))
	{
	
	//DEBUG display BEGIN
		$debug_html=<<<EOD
			Debug Info BEGIN<br>
			plugin_dir_path={$plugin_dir_path} <br>
			base_file={$base_file} <br>
			plugin_dir={$plugin_dir} <br>
			dir_base={$dir_base} <br>
			plugin_base_url={$plugin_base_url} <br>
			server_host={$_SERVER['HTTP_HOST']}<br>
			Is this admin ={$is_admin_user}<br>
			ABSPATH={$ABSPATH}<br>
			SITECOOKIEPATH={$SITECOOKIEPATH}<br>
			Upgrade details ={$update_details["mesg"]}<br>
			Debug Info END<br>	
EOD;
	//DEBUG display END
	}

	if (file_exists($plugin_dir_path."SRC_INFOCAPTOR.php")) //if the plugin is sourced from website
	{
		$register_html=<<<EOD
		<iframe scrolling="no" frameborder=0 src="{$plugin_base_url}/infocaptor/server_register.php" width=100% height=600></iframe>
EOD;

	}

	$info_html=<<<EOD
		<ul>
		<li><a href="https://www.infocaptor.com?x=wpinfo" target="_blank">InfoCaptor Website</a>
		<li><a href="{$icdash_ns_options["PluginURI"]}?x=wpinfo" target="_blank">Plugin Page</a>
		</ul>
EOD;

$info_tab=<<<EOD
<div id="info-tab">
   {$info_html}
   {$register_html}
	
</div><!--id="info-tab"-->

EOD;
	
/*global $submenu;
$menu_list=print_r($submenu, true); 	*/
$config_html=<<<EOD
<div id="icdash-main" class="wrap">
<script>
icdash_global={};

icdash_global["script_url"]=[
	 "{$plugin_base_url}/infocaptor/woo_ic_install.php?mode=woo_manual_install"
];
icdash_global["data_load_url"]=[
	 "{$plugin_base_url}/infocaptor/woo_ic_load_data.php"
];
icdash_global["install_complete"]='{$install_complete}';
icdash_global["download_url"]=[
	 "{$upgrade_script}"
];

</script>
	<h2>{$icdash_ns_options["Name"]} - v{$current_version}</h2>
	{$icdash_phpglb["install_html"]}
</div><!--id="icdash-main"-->
	
<br class="clear" />

<script>
jQuery("document").ready(function() {
		jQuery( "#icdash-tabs" ).tabs(); 
		
		//setup the datepicker for the setup tab
		jQuery("#icdash_etl_start_date").datepicker({
			dateFormat: "yy-mm-dd"
		});	 
	if (icdash_global["install_complete"]=="N")
	{
		jQuery( "#icdash-tabs" ).tabs(  "option", "active", 1 );
		jQuery( ".icdash_after_install").hide();
	}
	

	
});
</script>



<div id="icdash-tabs">
  <ul>
    <li><a href="#icdash-dashboard-tab">All Reports</a></li>
    <li><a href="#setup-tab">Data/Setup</a></li>
    <li><a href="#info-tab">Info</a></li>
  </ul>
  
  <div id="icdash-dashboard-tab">
		<div  class="icdash_after_install"  id="icdash-dashboard-list" class="wrap" {$show_dashboard_list}>
				<style>

				</style>
				{$list_of_dashboards}

		</div><!--id="icdash-dashboard-list"-->
  </div><!--id="icdash-dashboard-tab"-->
  
<br class="clear" />
EOD;

    echo $config_html;	

	
	icdash_options_admin_page(); //echo the admin settings
	echo $info_tab;	
	echo "</div> <!--icdash-tabs-->"; //end all the tabs wrapper
}



function icdash_woo_get_dashboard_list($plugin_dir,$plugin_url)
{
	$report_def = "{$plugin_dir}/reports/woocommerce/icdash_repo.php";
	include_once "{$report_def}";
	array_multisort(array_column($list_of_reports, 'category'), SORT_ASC,
                array_column($list_of_reports, 'seq'),      SORT_ASC,
                $list_of_reports);
				
	$output_html=" ";
	$dash_html="";
	$dash_file="";
	$dash_title="";
    $file="";
	foreach ($list_of_reports as $k => $v)
	{
	   $file=$list_of_reports[$k]["file"];

//		if(!is_dir($file.".php")) 
		{ 
		   $dash_file=$file;
			$dash_title=$k;
			$directory=$list_of_reports[$k]["dir"];
			$image_file=$list_of_reports[$k]["img"];
$dash_html=<<<EOD
<div class="woo_dashlet">
	<a title="Cached and Faster version of {$dash_title}"  class="woo_dashlet_link" href="{$plugin_url}/infocaptor/mt.php?pr={$directory}&pa={$dash_file}&v=__" target="_blank">
			<img class="woo_dash_img" src="{$plugin_url}/reports/woocommerce/{$image_file}">
			{$dash_title}
	</a>
	<br>
	<a title="Non Cached version of {$dash_title}. Slower compared to Cached" class="woo_dashlet_link_noncache" href="{$plugin_url}/infocaptor/mt.php?pr={$directory}&pa={$dash_file}&v=__&view_suffix=v" target="_blank">
			Non Cached version
	</a>
</div>
EOD;
			$output_html.=$dash_html;
   
		}
	}
	
	return $output_html;
}



//load this only if icdash admin page is invoked
function icdash_woo_load_js()
{
  add_action('admin_enqueue_scripts', __NAMESPACE__.'\icdash_woo_admin_scripts');
}



function icdash_woo_admin_scripts() 
{
	$dir_base=basename(__DIR__);
	$plugin_base_url=plugins_url()."/".$dir_base;

	wp_enqueue_style('jquery-ui-css-style',$plugin_base_url. '/admin/css/jquery-ui.min.css', array(), false, 'screen');	

	wp_enqueue_style( 'jquery-ui-css-style' );	
	wp_enqueue_style('icdash-admin-ui', $plugin_base_url. '/admin/css/dash-reports-woocommerce-ic-admin.css?v='.ICDASH_WOO_IC_VERSION, array(), false, 'screen');	

	wp_enqueue_script('jquery-ui-datepicker', '', array('jquery-ui-core', 'jquery'));
	wp_enqueue_script('jquery-ui-tabs', '', array('jquery-ui-core', 'jquery'));
	wp_enqueue_script('jquery-ui-dialog', '', array('jquery-ui-core', 'jquery'));
	wp_enqueue_script('jquery-ui-button', '', array('jquery-ui-core', 'jquery'));
	wp_register_script('icdash_woo_install_ajax', plugins_url('/admin/js/dash-reports-woocommerce-ic-admin.js?v='.ICDASH_WOO_IC_VERSION,__FILE__), array('jquery'),'',true);
	wp_enqueue_script('icdash_woo_install_ajax');
	
}

// create a scheduled event (if it does not exist already)
function icdash_cron_activation() 
{
	// when you think of visiting me ..call the cron
	add_action('infocaptor_cron_job_hook',__NAMESPACE__.'\icdash_woo_daily_load_exec'); //associate the cron_job to the actual function that will run every day/hour

	if( !wp_next_scheduled( 'infocaptor_cron_job_hook' ) ) //check if cron hook is defined, if defined it will send the next run time. if not defined then define a new schedule
	{  
	   
	   wp_schedule_event( time() + 60*60 , 'hourly', 'infocaptor_cron_job_hook' );	
	}

}


function icdash_woo_daily_load_exec() //called by infocaptor_cron_job_hook via wp cron
{
	//function to call the stored proc

	global $wpdb;
	$wpdb->query("call ic_woo_daily_load('null','null','WOO_TABLE_SYNC')");

}

// define the wp_logout callback 
function icdash_action_wp_logout() 
{ 
	global $secure;

    setcookie(ICDASH_LOGIN_TOKEN, "", time() - 3600, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	
    setcookie(WPICDASH_TOKEN, ""    , time() - 3600, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	
	setcookie(ICDASH_ADMIN_TOKEN, ""    , time() - 3600, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	

	
}; 
    
function icdash_set_cookies()
{
  global $secure;
	$tk1=ICDASH_LOGIN_TOKEN;
	$tk2=WPICDASH_TOKEN;
	//setcookie( TEST_COOKIE, 'WP Cookie check', 0, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	
	setcookie(ICDASH_LOGIN_TOKEN, "595752746157343d", time()+86400, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	
	setcookie(WPICDASH_TOKEN	, "11Y11EE11SS"     , time()+86400, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );		
	


}	

/**
 * This is special code needed for the demo purpose. This removes unnecessary menus for the demo account
 */
function icdash_remove_menu_pages() 
{
	icdash_register_options();

	//now code for the non admin user
$current_user = wp_get_current_user();

	 if (!in_array('administrator',  wp_get_current_user()->roles))
	 {
	   remove_menu_page('link-manager.php');
	   remove_menu_page('index.php');
	   remove_menu_page('options-general.php');
	   remove_menu_page('users.php');
	   remove_menu_page('tools.php');
	   remove_menu_page('edit.php');
	   remove_menu_page('edit-comments.php');
	   remove_menu_page('profile.php');
	   
	   remove_submenu_page("woocommerce","wc-reports");
	   remove_submenu_page("woocommerce","wc-settings");
	   remove_submenu_page("woocommerce","wc-addons");
	   remove_submenu_page("woocommerce","wc-status");


	 }
}

/**
 * This code enables auto updates for private plugins
 */
function icdash_activate_auto_update()
{
	require_once ( 'wp_autoupdate.php' );
	$plugin_current_version = ICDASH_WOO_IC_VERSION;
	$plugin_remote_path = WPICDASH_AUTOUPDATE_URL;
	$plugin_slug = plugin_basename( __FILE__ );
	$license_user = 'user';
	$license_key = 'abcd';
	new WP_AutoUpdate ( $plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key );
}

/**
 * This code checks the server if any new version available. Returns False if no new version. If new version available then it returns details on how to fetch new updates.
 */
function icdash_is_new_update($plugin_dir_path,$plugin_slug)
{

	$icdash_server_updates = get_transient( constant(__NAMESPACE__.'ICDASH_UPGRADE_CHECK') );
	$transient_duration=DAY_IN_SECONDS;
	if (ICDASH_DEBUG_MODE=="YES")
	{
		$transient_duration=300; // 5 mins
		$debug_mesg=" ";
	}	

  if (!$icdash_server_updates) //did we cache any updates from our last ping?
  {
    //if the transient expired means we need to fetch new value from server
	   //load the http request library
	   if (!class_exists('Requests')) 
	   {
			require_once $plugin_dir_path. 'infocaptor/system/requests_php/library/Requests.php';
			// load needed internal classes
			Requests::register_autoloader();
		}	
		$params=array(
					'action'       => 'check_new_updates',
					'license_user' => 'dummy_user',
					'license_key'  => 'dummy_key',
					'plugin-slug'  => $plugin_slug
				);
		// Now let's make a request!
		$options = array('user-agent' => "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.124 Safari/537.36"
		,'verify' => false
		,'verifyname' => false
		);
		$request = \Requests::post(WPICDASH_AUTOUPDATE_URL, array(), $params,$options);
		$req_string=$request->body;
		$req_body=unserialize($req_string);	

		//set transient indicating we checked for new updates and need to hold off next time
		set_transient( constant (__NAMESPACE__.'ICDASH_UPGRADE_CHECK'), $req_string, $transient_duration );	
		$debug_mesg="<br>No cache. Server pinged to get new updates<br>";	
  }
  else
  {
		$req_string=$icdash_server_updates; //if the value was cached then this will contain the serialized array value
		$req_body=unserialize($req_string);	
  		$debug_mesg="<br>Cache found. Updates decoded from the cache<br>";	
  }

	if (ICDASH_DEBUG_MODE!="YES")
	{
		$debug_mesg=" ";
	}
	
	if ( version_compare( ICDASH_WOO_IC_VERSION, $req_body["new_version"], '<' ) ) 
	{
		$req_body["available"]=true;  
		$req_body["mesg"]="Server reported availability of a new version".$debug_mesg;
	}
	else 
	{
		$req_body["available"]=false;
		$req_body["mesg"]="Checked the server but no new version available".$debug_mesg;
	 } 
	//var_dump($req_body);
	return $req_body;
	
}

//check if the current logged user is admin or not
function icdash_check_admin_user()
{
global $secure;
	$current_user = wp_get_current_user();
	if ( 0 == $current_user->ID ) 
	{
		setcookie(ICDASH_ADMIN_TOKEN	, ICDASH_IS_NO_USER     , time()+86400, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	
		return ICDASH_IS_NO_USER;
	}

	if (!in_array('administrator',  wp_get_current_user()->roles)) 
	{
	   setcookie(ICDASH_ADMIN_TOKEN	, ICDASH_IS_NO_ADMIN     , time()+86400, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	
	   return ICDASH_IS_NO_ADMIN;
	}
	else
    {
	   setcookie(ICDASH_ADMIN_TOKEN	, ICDASH_IS_ADMIN     , time()+86400, SITECOOKIEPATH, COOKIE_DOMAIN, $secure );	
	   return ICDASH_IS_ADMIN;
	}	
}

// 6.9
// hint: returns the requested page option value or it's default
function icdash_get_option( $option_name ) {
	
	// setup return variable
	$option_value = '';	
	
	
	try {
		
		// get default option values
		// get the requested option
		switch( $option_name ) {
			
			case 'icdash_etl_start_date':
				//$option_value = (get_option('icdash_etl_start_date')) ? get_option('icdash_etl_start_date') : date('Y-m-d', strtotime('-2 year'));
				$option_value = get_option('icdash_etl_start_date');
				if (!$option_value)
				{
					$option_value=date("Y-m-d", strtotime("-1 year", time()));
					update_option('icdash_etl_start_date', $option_value);
				}
				break;
			case 'icdash_etl_increment_days':			
				
				$option_value = get_option('icdash_etl_increment_days');
				if (!$option_value)
				{
					$option_value=30;
					update_option('icdash_etl_increment_days', $option_value);
				}				
				break;				

			
		}
		
	} catch( Exception $e) {
		
		// php error
		
	}
	
	// return option value or it's default
	return $option_value;
	
}


// hint: get's the current options and returns values in associative array
function icdash_get_current_options() {
	
	// setup our return variable
	$current_options = array();
	
	try {
	
		// build our current options associative array
		$current_options = array(
			'icdash_etl_start_date' => icdash_get_option('icdash_etl_start_date'),
			'icdash_etl_increment_days' => icdash_get_option('icdash_etl_increment_days')
			
		);
	
	} catch( Exception $e ) {
		
		// php error
	
	}
	
	// return current options
	return $current_options;
	
}



// hint: plugin options admin page
function icdash_options_admin_page() 
{
	global $icdash_phpglb;
	//temp_setup_infocaptor_db();
	// get the default values for our options
	$options = icdash_get_current_options();
	
	//NOTE add restriction for non admin roles $icdash_phpglb["is_admin_role"]="Y";
	
	//NOTE: Make sure any new options are added in the activator with default values
	echo('<div id="setup-tab">
	<button type="button" title="Reset only if you encounter problems during initial install or trying to fix something" class="button-primary icdash_after_install" id="icdash_activate_install_again"> Reset Full Install </button> 
		<div class="icdash_after_install" id="icdash-setup-left">
		
		<h2>Setup/Config options</h2>
		
		<form action="options.php" id="icdash_settings_form" method="post">');
		
			// outputs a unique nounce for our plugin options
			settings_fields(constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS'));
			// generates a unique hidden field with our form handling url
			//@do_settings_fields(ICDASH_PLUGIN_OPTIONS);
			
			echo('<table class="form-table">
			
				<tbody>
			
					<tr>
						<th scope="row"><label for="icdash_etl_start_date">Load data from </label></th>
						<td>
							<input  type="start_date" id="icdash_etl_start_date" name="icdash_etl_start_date" value="'.$options['icdash_etl_start_date'].'" /> 

						</td>
					</tr>
					<tr>
						<th scope="row"><label for="icdash_etl_increment_days">Increment Days </label></th>
						<td>
							<input  type="number" id="icdash_etl_increment_days" name="icdash_etl_increment_days" value="'.$options['icdash_etl_increment_days'].'" /> 

						</td>
					</tr>
					
			

			
				</tbody>
				
			  </table>
			</form>
			');
		
			// outputs the WP submit button html
			//@submit_button(); //temporary disabled
		
		if ($icdash_phpglb["is_admin_role"]=="Y")
		{
		echo('
			
<button type="button" class="button-primary" style="font-size:28px;height:46px;" id="icdash_load_incremental"> Start Incremental Data Load </button>
<br><a href="https://www.infocaptor.com/how-to-setup-and-use-woocommerce-reporting#Process_Initial_Data_and_setup_Incremental_Data_load" target="_blank">Help - How to load data</a>
			');
		}
		
	   echo('	  
	</div><!--icdash-setup-left-->
<div class="icdash_after_install" id="icdash-setup-right" style="padding:10px;margin:10px;">
	<div class="data_note_box" style="display:none;font-size:110%;text-decoration:none; color:#000; background:#ffc;padding:10px;">
		<p>
		NOTE: Use the "Load from date" and "Incremental Days" to perform a one time historical data processing.
		</p>
		<p>
		For e.g. If your Load Start date is 2017-01-01 and Incremental Days is 15 
		then the first batch of orders will be processed from 2017-01-01 through 2017-01-15 i.e 15 days worth of history will be processed
		</p>
		<p>
		Next, it will increment the batch and process from 2017-01-16 through 2017-01-31. 
		</p>
		<p>
		If your store is processing high volume of orders and the load seems to error out then try reducing the Incremental days to a lower value.
		For e.g If your batch errors out at 30 days then lower the value to 15 and restart the process. If it errors again then lower the value to say 5 and restart.
		</p>
		<p>
		For extreme high volume stores, we may need to setup a hourly processing cron job. 
		<a href="https://www.infocaptor.com/woocommerce-reports-and-dashboards?x='.WPICDASH_TOKEN.'" target="_blank">Please contact us for more instructions</a> 
		</p>
	</div>	
</div>
<!--progress section-->
			  <div id="icdash-progress-parent" style="display:none;">
					<div id="result_header" style="border:0px solid #000; padding:10px; width:500px; visibility: "></div>
					<div id="results" style="border:0px solid #000; padding:10px; width:500px; height:250px; overflow:auto; background:#eee;"></div>
					<br />
					  
					<!--progress id="progressor" value="0" max="100" style="width:520px;padding:10px; "></progress>  
					<span id="percentage" style="text-align:right; display:block; margin-top:5px;">0</span-->		
			  </div><!--id="icdash-progress-parent"-->
<!--progress section-->	
<div id="icdash_dialog" style="display:none;" title="Setup Information">
  <p>Your basic install of all the report objects is complete. Please proceed to process historical data by selecting the <strong>Load From date</strong> and click on the <strong>"Start Incremental Data Load"</strong></p>
</div>
</div><!--id="setup-tab"-->
	
	
	');
	
}






// hint: registers all our plugin options
function icdash_register_options() {
	// plugin options: The group name should be matching the menu slug 
	register_setting(constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS'), 'icdash_etl_start_date');
	register_setting(constant(__NAMESPACE__.'ICDASH_PLUGIN_OPTIONS'), 'icdash_etl_increment_days');
	

}

/*
function temp_setup_infocaptor_db()
{

   require_once plugin_dir_path( __FILE__ ) . '/includes/class-infocaptor-db.php';	
   include plugin_dir_path( __FILE__ )."infocaptor/system/property_definition.php";
   
   global $icdb;
   global $wpdb;

//create the needed upload subdirectories
	$upload = wp_upload_dir();
    $upload_dir = $upload['basedir'];
	$upload_sub_dir = wp_normalize_path($upload_dir . '/infocaptor/data/admin');
	echo $upload_sub_dir;

	if ( ! file_exists( $upload_sub_dir ) ) 
	{
		echo "directory does not exist";
		if (wp_mkdir_p( $upload_sub_dir )=== TRUE)
		{
			//director exists or created
			//if not then use alternative loc
		}
		else
		{
			//alternative location
		}
    }

   $icdb = new infoDB($wpdb);
   $dbhost=$icdb->getDbHost();
   $dbport="3306";
   $dbuser=$icdb->getDbUser();
   $dbpass=$icdb->getDbPass();
   $dbname=$icdb->getDbName();
   $content_path=wp_normalize_path(WP_CONTENT_DIR);	
   
		$d="$";	  
$db_file=<<<SOD
<?php
//db details set using wpdb

{$d}xdb_array['repository']['type']="mysql";
{$d}xdb_array['repository']['host']="{$dbhost}";
{$d}xdb_array['repository']['port']="{$dbport}";
{$d}xdb_array['repository']['user']="{$dbuser}";
{$d}xdb_array['repository']['pass']="{$dbpass}";
{$d}xdb_array['repository']['name']="{$dbname}";
{$d}xdb_array['repository']['table_prefix']="{$wpdb->prefix}";
{$d}xdb_array['repository']['wpcontent']="{$content_path}";


?>
SOD;

		$result=$property['tofile']("{$property['dbconfig_location']}",$db_file);		//xmember dbconfig so that when designer is used it knows where to connect
		
		$admin_api_id=sha1("NONE1"."23xcER920DJFUInfoCaptor");

		$key=$dbuser.substr($admin_api_id, 1, 11);
		$encrypted = xa_encrypt_decrypt("encrypt",$key, $dbpass); 	
		$db_file=<<<SOD
		<?php
		//db details set using wpdb

		{$d}db_param["type"]='mysql';
		{$d}db_param["driver_str"]='';
		{$d}db_param["dbname"]='{$dbname}';
		{$d}db_param["host"]='{$dbhost}';
		{$d}db_param["port"]='{$dbport}';
		{$d}db_param["dbuser"]='{$dbuser}';
		{$d}db_param["dbpass"]='{$encrypted}';
		{$d}db_param["connection_description"]='woocommerce database';
		{$d}db_param['table_prefix']="{$wpdb->prefix}";
		{$d}db_param['wpcontent']="{$content_path}";


		?>
SOD;
		$result=$property['tofile']("{$property['data_dir']}/admin/woocommerce_db.php",$db_file);		//woo handle so the dashboards can connect
}

	function  xa_encrypt_decrypt($action,$key, $string) 
	{
		$output = false;
		$encrypt_method = "AES-256-CBC";
		$secret_key = $key." key";
		$secret_iv = $key." iv";
		// hash
		$key = hash('sha256', $secret_key);
		
		// iv - encrypt method AES-256-CBC expects 16 bytes - else you will get a warning
		$iv = substr(hash('sha256', $secret_iv), 0, 16);
		if ( $action == 'encrypt' ) {
			$output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
			$output = base64_encode($output);
		} else if( $action == 'decrypt' ) {
			$output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
		}
		return $output;
	}
	
*/	




?>