<?php

/**
 * Fired during plugin deactivation
 *
 * @link       https://www.infocaptor.com
 * @since      1.0.0
 *
 * @package    Dash_Reports_Woocommerce_Ic
 * @subpackage Dash_Reports_Woocommerce_Ic/includes
 */

/**
 * Fired during plugin deactivation.
 *
 * This class defines all code necessary to run during the plugin's deactivation.
 *
 * @since      1.0.0
 * @package    Dash_Reports_Woocommerce_Ic
 * @subpackage Dash_Reports_Woocommerce_Ic/includes
 * @author     Nilesh Jethwa <contact@infocaptor.com>
 */
class Dash_Reports_Woocommerce_Ic_Deactivator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function deactivate() 
	{
	
		delete_option( 'icdash_woo_key' );
		static::icdash_cron_deactivate();
		delete_option( 'icdash_woo_install_core' );
		delete_option( 'icdash_woo_install_views' );
		//delete_option( 'icdash_woo_core_seedata' );
		delete_option( 'icdash_etl_start_date');
		delete_option( 'icdash_etl_increment_days');
		
	}
	
// unschedule event upon plugin deactivation
   public static function icdash_cron_deactivate() 
   {	
		// find out when the last event was scheduled
		$timestamp = wp_next_scheduled ('infocaptor_cron_job_hook');
		// unschedule previous event if any
		wp_unschedule_event ($timestamp, 'infocaptor_cron_job_hook');
	} 

	

}
