<?php

/**
 * Define the internationalization functionality
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @link       https://www.infocaptor.com
 * @since      1.0.0
 *
 * @package    Dash_Reports_Woocommerce_Ic
 * @subpackage Dash_Reports_Woocommerce_Ic/includes
 */

/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @since      1.0.0
 * @package    Dash_Reports_Woocommerce_Ic
 * @subpackage Dash_Reports_Woocommerce_Ic/includes
 * @author     Nilesh Jethwa <contact@infocaptor.com>
 */
class Dash_Reports_Woocommerce_Ic_i18n {


	/**
	 * Load the plugin text domain for translation.
	 *
	 * @since    1.0.0
	 */
	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'dash-reports-woocommerce-ic',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

	}



}
