
CREATE or replace
VIEW `ic_woo_prefix_v` AS
    SELECT '{$wp_prefix}' as prefix
;



CREATE or replace
VIEW `ic_woo_order_items_v` AS
    SELECT 
        `woi`.`order_item_name` AS `order_item_name`,
        `woi`.`order_item_type` AS `order_item_type`,
        `woi`.`order_id` AS `order_id`,
        `woim`.`order_item_id` AS `order_item_id`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_product_id') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `product_id`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_variation_id') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `variation_id`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_qty') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `qty`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_tax_class') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `tax_class`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_line_subtotal') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `line_subtotal`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_line_subtotal_tax') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `line_subtotal_tax`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_line_total') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `line_total`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_line_tax') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `line_tax`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_line_tax_data') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `line_tax_data`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'method_id') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `method_id`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'instance_id') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `instance_id`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'cost') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `cost`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'total_tax') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `total_tax`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'taxes') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `taxes`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'Items') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `Items`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'rate_id') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `rate_id`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'label') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `label`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'compound') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `compound`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'tax_amount') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `tax_amount`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'shipping_tax_amount') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `shipping_tax_amount`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = 'discount_amount') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `discount_amount`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_wc_cog_item_cost') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `wc_cog_item_cost`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_wc_cog_item_total_cost') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `wc_cog_item_total_cost`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_is_deposit') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `is_deposit`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_deposit_full_amount') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `deposit_full_amount`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_deposit_full_amount_ex_tax') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `deposit_full_amount_ex_tax`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_deposit_deposit_amount_ex_tax') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `deposit_deposit_amount_ex_tax`,
        MAX((CASE
            WHEN (`woim`.`meta_key` = '_remaining_balance_paid') THEN `woim`.`meta_value`
            ELSE NULL
        END)) AS `deposit_remaining_balance_paid`
    FROM
        (`{$wp_prefix}woocommerce_order_itemmeta` `woim`
        JOIN `{$wp_prefix}woocommerce_order_items` `woi`)
    WHERE
        (`woim`.`order_item_id` = `woi`.`order_item_id`)
    GROUP BY `woi`.`order_item_name` , `woi`.`order_item_type` , `woi`.`order_id` , `woim`.`order_item_id`
;


CREATE  or replace
VIEW `ic_woo_orders_v` AS
    SELECT 
        `wp`.`ID` AS `order_id`,
        `wp`.`post_date` AS `order_date`,
        `wp`.`post_status` AS `order_status`,
        `wp`.`post_name` AS `post_order_number`,
        `wp`.`post_modified` AS `order_modified_date`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_key') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_key`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_currency') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_currency`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_prices_include_tax') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `prices_include_tax`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_number') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_number`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_shipping') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_shipping`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_fee_total') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `fee_total`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_fee_tax_total') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `fee_tax_total`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_discount_total') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `discount_total`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_customer_user') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `customer_user`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_cart_discount') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `cart_discount`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_discount') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_discount`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_total') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_total`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_payment_method') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `payment_method`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_payment_method_title') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `payment_method_title`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_customer_email') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `customer_email`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_first_name') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_first_name`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_last_name') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_last_name`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_company') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_company`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_address_1') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_address_1`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_address_2') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_address_2`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_city') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_city`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_state') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_state`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_postcode') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_postcode`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_country') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_country`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_email') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_email`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_phone') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_phone`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_first_name') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_first_name`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_last_name') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_last_name`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_company') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_company`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_address_1') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_address_1`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_address_2') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_address_2`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_city') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_city`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_state') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_state`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_postcode') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_postcode`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_country') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_country`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_method') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_method`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_method_title') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_method_title`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_download_permissions_granted') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `download_permissions_granted`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_download_permissions') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `download_permissions`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_tax') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_tax`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_shipping_tax') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_shipping_tax`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_recorded_sales') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `recorded_sales`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_created_via') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `created_via`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_cart_discount_tax') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `cart_discount_tax`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_version') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_version`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_billing_address_index') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `billing_address_index`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_shipping_address_index') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `shipping_address_index`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_edit_last') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `edit_last`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_date_completed') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `date_completed`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_date_paid') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `date_paid`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_paid_date') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `paid_date`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_completed_date') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `completed_date`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_recorded_coupon_usage_counts') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `recorded_coupon_usage_counts`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_order_stock_reduced') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `order_stock_reduced`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_customer_ip_address') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `customer_ip_address`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_customer_user_agent') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `customer_user_agent`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_cart_hash') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `cart_hash`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = 'is_vat_exempt') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `is_vat_exempt`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_cog_order_total_cost') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `wc_cog_order_total_cost`,
        (SELECT 
                'Yes'
            FROM
                (`{$wp_prefix}woocommerce_order_items` `woi`
                JOIN `{$wp_prefix}woocommerce_order_itemmeta` `woim`)
            WHERE
                ((`woi`.`order_id` = `wp`.`ID`)
                    AND (`woi`.`order_item_type` = 'line_item')
                    AND (`woi`.`order_item_id` = `woim`.`order_item_id`)
                    AND (`woim`.`meta_key` = '_is_deposit')
                    AND (`woim`.`meta_value` = 'yes'))
            LIMIT 1) AS `is_deposit_order`
FROM
        (`{$wp_prefix}postmeta` `wpd`
        JOIN `{$wp_prefix}posts` `wp`)
    WHERE
        ((`wp`.`ID` = `wpd`.`post_id`)
            AND (`wp`.`post_type` = 'shop_order'))
    GROUP BY `wp`.`ID` , `wp`.`post_date` , `wp`.`post_status` , `wp`.`post_name` , `wp`.`post_modified`
;


CREATE  or replace
VIEW `ic_woo_prod_details_v` AS
    SELECT 
        `wp`.`ID` AS `product_id`,
        `wp`.`post_date` AS `product_created`,
        `wp`.`post_status` AS `product_status`,
        `wp`.`post_name` AS `product_name`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sku') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sku`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = 'total_sales') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `total_sales`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_tax_status') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_tax_status`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_tax_class') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_tax_class`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_manage_stock') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_manage_stock`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_backorders') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_backorders`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sold_individually') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sold_individually`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_virtual') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_virtual`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_downloadable') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_downloadable`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_download_limit') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_download_limit`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_download_expiry') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_download_expiry`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_stock') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_stock`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_stock_status') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_stock_status`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_average_rating') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_average_rating`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_review_count') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_review_count`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_version') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_version`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wpcom_is_markdown') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wpcom_is_markdown`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wp_old_slug') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wp_old_slug`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_length') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_length`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_width') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_width`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_height') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_height`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_image_gallery') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_image_gallery`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_thumbnail_id') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_thumbnail_id`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_attributes') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_attributes`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_regular_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_regular_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sale_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sale_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_downloadable_files') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_downloadable_files`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_edit_lock') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_edit_lock`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_children') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_children`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_url') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_url`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_button_text') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_button_text`
    FROM
        (`{$wp_prefix}postmeta` `wpd`
        JOIN `{$wp_prefix}posts` `wp`)
    WHERE
        ((`wp`.`ID` = `wpd`.`post_id`)
            AND (`wp`.`post_type` IN ('product' , 'product_variation')))
    GROUP BY `wp`.`ID` , `wp`.`post_date` , `wp`.`post_status` , `wp`.`post_name`
;


CREATE  or replace
VIEW `ic_woo_product_attributes_v` AS
    SELECT 
        `item`.`ID` AS `product_id`,
        `item`.`post_date` AS `product_created`,
        `item`.`post_status` AS `product_status`,
        `item`.`post_name` AS `product_name`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_type') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_type`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_visibility') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_visibility`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_cat') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_cat`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_tag') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_tag`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'pa_color') THEN `wt`.`name`
            ELSE NULL
        END)) AS `pa_color`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'pa_size') THEN `wt`.`name`
            ELSE NULL
        END)) AS `pa_size`
    FROM
        (((`{$wp_prefix}posts` `item`
        JOIN `{$wp_prefix}term_relationships` `tr`)
        JOIN `{$wp_prefix}term_taxonomy` `tt`)
        JOIN `{$wp_prefix}terms` `wt`)
    WHERE
        ((`item`.`post_type` IN ('product' , 'product_variation'))
            AND (`item`.`ID` = `tr`.`object_id`)
            AND (`tr`.`term_taxonomy_id` = `tt`.`term_taxonomy_id`)
            AND (`tt`.`term_id` = `wt`.`term_id`))
    GROUP BY `item`.`ID` , `item`.`post_date` , `item`.`post_status` , `item`.`post_name`
;


CREATE  or replace
VIEW `ic_woo_product_multi_attrib_v` AS
    SELECT 
        `item`.`ID` AS `product_id`,
        `item`.`post_date` AS `product_created`,
        `item`.`post_status` AS `product_status`,
        `item`.`post_name` AS `product_name`,
        `tt`.`term_taxonomy_id` AS `term_taxonomy_id`,
        `tt`.`taxonomy` AS `taxonomy`,
        `tt`.`parent` AS `parent_category_id`,
        `wt`.`term_id` AS `term_id`,
        `wt`.`name` AS `term_name`,
        `wt`.`slug` AS `slug`,
        `wt`.`term_group` AS `term_group`,
        `tr`.`term_order` AS `term_order`
    FROM
        (((`{$wp_prefix}posts` `item`
        JOIN `{$wp_prefix}term_relationships` `tr`)
        JOIN `{$wp_prefix}term_taxonomy` `tt`)
        JOIN `{$wp_prefix}terms` `wt`)
    WHERE
        ((`item`.`post_type` IN ('product' , 'product_variation'))
            AND (`item`.`ID` = `tr`.`object_id`)
            AND (`tr`.`term_taxonomy_id` = `tt`.`term_taxonomy_id`)
            AND (`tt`.`term_id` = `wt`.`term_id`))
;


CREATE  or replace
VIEW `ic_woo_product_uniq_attrib_v` AS
    SELECT 
        `item`.`ID` AS `product_id`,
        `item`.`post_date` AS `product_created`,
        `item`.`post_status` AS `product_status`,
        `item`.`post_name` AS `product_name`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_type') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_type`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_visibility') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_visibility`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_cat') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_cat`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_tag') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_tag`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'pa_color') THEN `wt`.`name`
            ELSE NULL
        END)) AS `pa_color`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'pa_size') THEN `wt`.`name`
            ELSE NULL
        END)) AS `pa_size`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sku') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sku`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = 'total_sales') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `total_sales`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_tax_status') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_tax_status`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_tax_class') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_tax_class`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_manage_stock') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_manage_stock`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_backorders') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_backorders`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sold_individually') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sold_individually`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_virtual') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_virtual`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_downloadable') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_downloadable`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_download_limit') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_download_limit`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_download_expiry') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_download_expiry`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_stock') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_stock`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_stock_status') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_stock_status`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_average_rating') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_average_rating`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_review_count') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_review_count`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_version') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_version`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wpcom_is_markdown') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wpcom_is_markdown`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wp_old_slug') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wp_old_slug`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_length') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_length`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_width') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_width`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_height') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_height`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_image_gallery') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_image_gallery`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_thumbnail_id') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_thumbnail_id`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_attributes') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_attributes`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_regular_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_regular_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sale_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sale_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_downloadable_files') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_downloadable_files`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_edit_lock') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_edit_lock`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_children') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_children`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_product_url') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_product_url`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_button_text') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_button_text`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_weight') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_weight`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_min_variation_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_min_variation_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_max_variation_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_max_variation_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_min_variation_regular_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_min_variation_regular_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_max_variation_regular_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_max_variation_regular_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_min_variation_sale_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_min_variation_sale_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_max_variation_sale_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_max_variation_sale_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_min_variation_period') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_min_variation_period`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_max_variation_period') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_max_variation_period`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_min_variation_period_interval') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_min_variation_period_interval`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_max_variation_period_interval') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_max_variation_period_interval`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_price') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_price`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_period') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_period`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_period_interval') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_period_interval`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_sign_up_fee') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_sign_up_fee`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_trial_period') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_trial_period`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_trial_length') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_trial_length`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_length') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_length`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_limit') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_limit`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_cog_cost_variable') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_cog_cost_variable`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_cog_cost') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_cog_cost`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_cog_min_variation_cost') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_cog_min_variation_cost`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_cog_max_variation_cost') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_cog_max_variation_cost`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_cog_default_cost') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_cog_default_cost`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_one_time_shipping') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_one_time_shipping`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_deposit_enabled') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_deposit_enabled`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_deposit_type') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_deposit_type`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_deposit_amount') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_deposit_amount`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_deposit_payment_plans') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_deposit_payment_plans`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_deposit_selected_type') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_deposit_selected_type`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_wc_deposit_multiple_cost_by_booking_persons') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_wc_deposit_multiple_cost_by_booking_persons`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_subscription_payment_sync_date') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_subscription_payment_sync_date`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sale_price_dates_from') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sale_price_dates_from`,
        MAX((CASE
            WHEN (`wpd`.`meta_key` = '_sale_price_dates_to') THEN `wpd`.`meta_value`
            ELSE NULL
        END)) AS `_sale_price_dates_to`,
        MAX((CASE
            WHEN (`tt`.`taxonomy` = 'product_brand') THEN `wt`.`name`
            ELSE NULL
        END)) AS `product_brand`
    FROM
        ((((`{$wp_prefix}posts` `item`
        JOIN `{$wp_prefix}term_relationships` `tr`)
        JOIN `{$wp_prefix}term_taxonomy` `tt`)
        JOIN `{$wp_prefix}terms` `wt`)
        JOIN `{$wp_prefix}postmeta` `wpd`)
    WHERE
        ((`item`.`post_type` IN ('product' , 'product_variation'))
            AND (`item`.`ID` = `tr`.`object_id`)
            AND (`item`.`ID` = `wpd`.`post_id`)
            AND (`tr`.`term_taxonomy_id` = `tt`.`term_taxonomy_id`)
            AND (`tt`.`term_id` = `wt`.`term_id`))
    GROUP BY `item`.`ID` , `item`.`post_date` , `item`.`post_status` , `item`.`post_name`
;


CREATE  or replace
VIEW `ic_woo_full_details_v` AS
    SELECT 
        `wod`.`order_id` AS `order_id`,
        `wod`.`order_date` AS `order_date`,
        `wod`.`order_modified_date` AS `order_modified_date`,
        `wod`.`order_status` AS `order_status`,
        `wod`.`post_order_number` AS `post_order_number`,
        `wod`.`order_key` AS `order_key`,
        `wod`.`order_currency` AS `order_currency`,
        `wod`.`prices_include_tax` AS `prices_include_tax`,
        `wod`.`order_number` AS `order_number`,
        `wod`.`order_shipping` AS `order_shipping`,
        `wod`.`fee_total` AS `fee_total`,
        `wod`.`fee_tax_total` AS `fee_tax_total`,
        `wod`.`discount_total` AS `discount_total`,
        `wod`.`customer_user` AS `customer_user`,
        `wod`.`cart_discount` AS `cart_discount`,
        `wod`.`order_discount` AS `order_discount`,
        `wod`.`order_total` AS `order_total`,
        `wod`.`payment_method` AS `payment_method`,
        `wod`.`payment_method_title` AS `payment_method_title`,
        `wod`.`customer_email` AS `customer_email`,
        `wod`.`billing_first_name` AS `billing_first_name`,
        `wod`.`billing_last_name` AS `billing_last_name`,
        `wod`.`billing_company` AS `billing_company`,
        `wod`.`billing_address_1` AS `billing_address_1`,
        `wod`.`billing_address_2` AS `billing_address_2`,
        `wod`.`billing_city` AS `billing_city`,
        `wod`.`billing_state` AS `billing_state`,
        `wod`.`billing_postcode` AS `billing_postcode`,
        `wod`.`billing_country` AS `billing_country`,
        `wod`.`billing_email` AS `billing_email`,
        `wod`.`billing_phone` AS `billing_phone`,
        `wod`.`shipping_first_name` AS `shipping_first_name`,
        `wod`.`shipping_last_name` AS `shipping_last_name`,
        `wod`.`shipping_company` AS `shipping_company`,
        `wod`.`shipping_address_1` AS `shipping_address_1`,
        `wod`.`shipping_address_2` AS `shipping_address_2`,
        `wod`.`shipping_city` AS `shipping_city`,
        `wod`.`shipping_state` AS `shipping_state`,
        `wod`.`shipping_postcode` AS `shipping_postcode`,
        `wod`.`shipping_country` AS `shipping_country`,
        `wod`.`shipping_method` AS `shipping_method`,
        `wod`.`shipping_method_title` AS `shipping_method_title`,
        `wod`.`download_permissions_granted` AS `download_permissions_granted`,
        `wod`.`download_permissions` AS `download_permissions`,
        `wod`.`order_tax` AS `order_tax`,
        `wod`.`order_shipping_tax` AS `order_shipping_tax`,
        `wod`.`recorded_sales` AS `recorded_sales`,
        `wod`.`created_via` AS `created_via`,
        `wod`.`cart_discount_tax` AS `cart_discount_tax`,
        `wod`.`order_version` AS `order_version`,
        `wod`.`billing_address_index` AS `billing_address_index`,
        `wod`.`shipping_address_index` AS `shipping_address_index`,
        `wod`.`edit_last` AS `edit_last`,
        `wod`.`date_completed` AS `date_completed`,
        `wod`.`date_paid` AS `date_paid`,
        `wod`.`paid_date` AS `paid_date`,
        `wod`.`completed_date` AS `completed_date`,
        `wod`.`recorded_coupon_usage_counts` AS `recorded_coupon_usage_counts`,
        `wod`.`order_stock_reduced` AS `order_stock_reduced`,
        `wod`.`customer_ip_address` AS `customer_ip_address`,
        `wod`.`customer_user_agent` AS `customer_user_agent`,
        `wod`.`cart_hash` AS `cart_hash`,
        `wod`.`is_vat_exempt` AS `is_vat_exempt`,
        `woi`.`order_item_name` AS `order_item_name`,
        `woi`.`order_item_type` AS `order_item_type`,
        `woi`.`order_item_id` AS `order_item_id`,
        `woi`.`product_id` AS `product_id`,
        `woi`.`variation_id` AS `variation_id`,
        `woi`.`qty` AS `qty`,
        `woi`.`tax_class` AS `tax_class`,
        `woi`.`line_subtotal` AS `line_subtotal`,
        `woi`.`line_subtotal_tax` AS `line_subtotal_tax`,
        `woi`.`line_total` AS `line_total`,
        `woi`.`line_tax` AS `line_tax`,
        `woi`.`line_tax_data` AS `line_tax_data`,
        `woi`.`method_id` AS `method_id`,
        `woi`.`instance_id` AS `instance_id`,
        `woi`.`cost` AS `cost`,
        `woi`.`total_tax` AS `total_tax`,
        `woi`.`taxes` AS `taxes`,
        `woi`.`Items` AS `Items`,
        `woi`.`rate_id` AS `rate_id`,
        `woi`.`label` AS `label`,
        `woi`.`compound` AS `compound`,
        `woi`.`tax_amount` AS `tax_amount`,
        `woi`.`shipping_tax_amount` AS `shipping_tax_amount`,
        `woi`.`discount_amount` AS `discount_amount`,
        `woi`.`wc_cog_item_cost` AS `wc_cog_item_cost`,
        `woi`.`wc_cog_item_total_cost` AS `wc_cog_item_total_cost`,
        `woi`.`is_deposit` AS `is_deposit`,
        `woi`.`deposit_full_amount` AS `deposit_full_amount`,
        `woi`.`deposit_full_amount_ex_tax` AS `deposit_full_amount_ex_tax`,
        `woi`.`deposit_deposit_amount_ex_tax` AS `deposit_deposit_amount_ex_tax`,
        `woi`.`deposit_remaining_balance_paid` AS `deposit_remaining_balance_paid`,
        `iatt`.`product_created` AS `product_created`,
        `iatt`.`product_status` AS `product_status`,
        `iatt`.`product_type` AS `product_type`,
        `iatt`.`product_visibility` AS `product_visibility`,
        `iatt`.`product_cat` AS `product_cat`,
        `iatt`.`product_tag` AS `product_tag`,
        `iatt`.`pa_color` AS `pa_color`,
        `iatt`.`pa_size` AS `pa_size`,
        `iatt`.`_sku` AS `sku`,
        `iatt`.`total_sales` AS `total_sales`,
        `iatt`.`_tax_status` AS `tax_status`,
        `iatt`.`_manage_stock` AS `manage_stock`,
        `iatt`.`_backorders` AS `backorders`,
        `iatt`.`_sold_individually` AS `sold_individually`,
        `iatt`.`_virtual` AS `virtual`,
        `iatt`.`_downloadable` AS `downloadable`,
        `iatt`.`_download_limit` AS `download_limit`,
        `iatt`.`_download_expiry` AS `download_expiry`,
        `iatt`.`_stock` AS `stock`,
        `iatt`.`_stock_status` AS `stock_status`,
        `iatt`.`_wc_average_rating` AS `wc_average_rating`,
        `iatt`.`_wc_review_count` AS `wc_review_count`,
        `iatt`.`_product_version` AS `product_version`,
        `iatt`.`_price` AS `price`,
        `iatt`.`_wpcom_is_markdown` AS `wpcom_is_markdown`,
        `iatt`.`_length` AS `length`,
        `iatt`.`_width` AS `width`,
        `iatt`.`_height` AS `height`,
        `iatt`.`_product_image_gallery` AS `product_image_gallery`,
        `iatt`.`_thumbnail_id` AS `thumbnail_id`,
        `iatt`.`_product_attributes` AS `product_attributes`,
        `iatt`.`_regular_price` AS `regular_price`,
        `iatt`.`_sale_price` AS `sale_price`,
        `iatt`.`_children` AS `children`,
        `iatt`.`_product_url` AS `product_url`,
        `iatt`.`_weight` AS `weight`,
        `iatt`.`_min_variation_price` AS `min_variation_price`,
        `iatt`.`_max_variation_price` AS `max_variation_price`,
        `iatt`.`_min_variation_regular_price` AS `min_variation_regular_price`,
        `iatt`.`_max_variation_regular_price` AS `max_variation_regular_price`,
        `iatt`.`_min_variation_sale_price` AS `min_variation_sale_price`,
        `iatt`.`_max_variation_sale_price` AS `max_variation_sale_price`,
        `iatt`.`_min_variation_period` AS `min_variation_period`,
        `iatt`.`_max_variation_period` AS `max_variation_period`,
        `iatt`.`_min_variation_period_interval` AS `min_variation_period_interval`,
        `iatt`.`_max_variation_period_interval` AS `max_variation_period_interval`,
        `iatt`.`_subscription_price` AS `subscription_price`,
        `iatt`.`_subscription_period` AS `subscription_period`,
        `iatt`.`_subscription_period_interval` AS `subscription_period_interval`,
        `iatt`.`_subscription_sign_up_fee` AS `subscription_sign_up_fee`,
        `iatt`.`_subscription_trial_period` AS `subscription_trial_period`,
        `iatt`.`_subscription_trial_length` AS `subscription_trial_length`,
        `iatt`.`_subscription_length` AS `subscription_length`,
        `iatt`.`_subscription_limit` AS `subscription_limit`,
        `iatt`.`_wc_cog_cost_variable` AS `wc_cog_cost_variable`,
        `iatt`.`_wc_cog_cost` AS `wc_cog_cost`,
        `iatt`.`_wc_cog_min_variation_cost` AS `wc_cog_min_variation_cost`,
        `iatt`.`_wc_cog_max_variation_cost` AS `wc_cog_max_variation_cost`,
        `iatt`.`_wc_cog_default_cost` AS `wc_cog_default_cost`,
        `iatt`.`_subscription_one_time_shipping` AS `subscription_one_time_shipping`,
        `iatt`.`_wc_deposit_enabled` AS `wc_deposit_enabled`,
        `iatt`.`_wc_deposit_type` AS `wc_deposit_type`,
        `iatt`.`_wc_deposit_amount` AS `wc_deposit_amount`,
        `iatt`.`_wc_deposit_payment_plans` AS `wc_deposit_payment_plans`,
        `iatt`.`_wc_deposit_selected_type` AS `wc_deposit_selected_type`,
        `iatt`.`_wc_deposit_multiple_cost_by_booking_persons` AS `wc_deposit_mult_cost_persons`,
        `iatt`.`_subscription_payment_sync_date` AS `subscription_payment_sync_date`,
        `iatt`.`_sale_price_dates_from` AS `sale_price_dates_from`,
        `iatt`.`_sale_price_dates_to` AS `sale_price_dates_to`,
		`iatt`.`product_brand` AS `product_brand`
    FROM
        ((`ic_woo_order_items_v` `woi`
        JOIN `ic_woo_orders_v` `wod`)
        JOIN `ic_woo_product_uniq_attrib_v` `iatt`)
    WHERE
        ((`woi`.`order_id` = `wod`.`order_id`)
            AND (`woi`.`product_id` = `iatt`.`product_id`)
            AND (`woi`.`order_item_type` = 'line_item'))
;



 

insert into xjob(job_name,job_type,load_type,start_date,end_date,load_status,incremental_duration,
last_run_date,last_run_rows,last_run_status,description,creation_date,last_update_date,
username,connection_handler,tablestore,extrainfo1,extrainfo2,active)
values(
'WOO_TABLE_SYNC',	'mysql_stored_call',	'incremental'
,	now(),	now()
,	'pending',	60,	now(),0
,	'success',	'',	now(),	now(),	'admin',	'woocommerce_db',	'na','na','na',	'Y');




insert into xjob(job_name,job_type,load_type,start_date,end_date,load_status,incremental_duration,
last_run_date,last_run_rows,last_run_status,description,creation_date,last_update_date,
username,connection_handler,tablestore,extrainfo1,extrainfo2,active)
values(
'WOO_UI_LOAD',	'mysql_stored_call',	'incremental'
,	DATE(DATE_ADD(now(), INTERVAL -2 YEAR)),	DATE(DATE_ADD(now(), INTERVAL -2 YEAR))
,	'pending',	30,	DATE(DATE_ADD(now(), INTERVAL -2 YEAR)),0
,	'success',	'',	now(),	now(),	'admin',	'woocommerce_db',	'na','na','na',	'Y');





drop table IF EXISTS ic_woo_orders_mv;



drop table IF EXISTS ic_woo_full_details_mv;



CREATE TABLE `ic_woo_orders_mv` (
`order_id`   bigint(20) unsigned NOT NULL DEFAULT '0',	
`order_date`   datetime NOT NULL DEFAULT '0000-00-00 00:00:00',	
`order_status`   varchar(20) NOT NULL DEFAULT 'publish',	
`post_order_number`   varchar(200) NOT NULL DEFAULT '',	
`order_modified_date`   datetime,	
`order_key`   varchar(50),	
`order_currency`   varchar(10),	
`prices_include_tax`   varchar(10),	
`order_number`   varchar(50),	
`order_shipping`   decimal(10,2),	
`fee_total`   decimal(10,2),	
`fee_tax_total`   decimal(10,2),	
`discount_total`   decimal(10,2),	
`customer_user`   varchar(10),	
`cart_discount`   decimal(10,2),	
`order_discount`   decimal(10,2),	
`order_total`   decimal(10,2),	
`payment_method`   varchar(50),	
`payment_method_title`   varchar(50),	
`customer_email`   varchar(50),	
`billing_first_name`   varchar(50),	
`billing_last_name`   varchar(50),	
`billing_company`   varchar(50),	
`billing_address_1`   varchar(100),	
`billing_address_2`   varchar(100),	
`billing_city`   varchar(100),	
`billing_state`   varchar(100),	
`billing_postcode`   varchar(50),	
`billing_country`   varchar(50),	
`billing_email`   varchar(50),	
`billing_phone`   varchar(20),	
`shipping_first_name`   varchar(50),	
`shipping_last_name`   varchar(50),	
`shipping_company`   varchar(50),	
`shipping_address_1`   varchar(100),	
`shipping_address_2`   varchar(100),	
`shipping_city`   varchar(100),	
`shipping_state`   varchar(100),	
`shipping_postcode`   varchar(50),	
`shipping_country`   varchar(50),	
`shipping_method`   varchar(50),	
`shipping_method_title`   varchar(50),	
`download_permissions_granted`   varchar(10),	
`download_permissions`   varchar(10),	
`order_tax`   decimal(10,2),	
`order_shipping_tax`   decimal(10,2),	
`recorded_sales`   varchar(10),	
`created_via`   varchar(20),	
`cart_discount_tax`   decimal(10,2),	
`order_version`   varchar(10),	
`billing_address_index`   varchar(200),	
`shipping_address_index`   varchar(200),	
`edit_last`   varchar(50),	
`date_completed`   varchar(50),	
`date_paid`   varchar(50),	
`paid_date`   datetime,	
`completed_date`   datetime,	
`recorded_coupon_usage_counts`   varchar(10),	
`order_stock_reduced`   varchar(10),	
`customer_ip_address`   varchar(50),	
`customer_user_agent`   varchar(150),	
`cart_hash`   varchar(150),	
`is_vat_exempt`   varchar(10),	
`wc_cog_order_total_cost`  decimal(10,2),	
`is_deposit_order`  varchar(20),	
  UNIQUE KEY `idx_ic_woo_orders_mv_order_id` (`order_id`),
  KEY `idx_ic_woo_orders_mv_order_date` (`order_date`),
  KEY `idx_ic_woo_orders_mv_order_status` (`order_status`)
);


//rename the mvx to mv for final delivery

CREATE TABLE `ic_woo_full_details_mv` (
`order_id`   bigint(20) unsigned NOT NULL DEFAULT '0',
`order_date`   datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
`order_modified_date`   datetime,
`order_status`   varchar(20) NOT NULL DEFAULT 'publish',
`post_order_number`   varchar(200) NOT NULL DEFAULT '',
`order_key`   varchar(50),
`order_currency`   varchar(10),
`prices_include_tax`   varchar(10),
`order_number`   varchar(50),
`order_shipping`   decimal(10,2),
`fee_total`   decimal(10,2),
`fee_tax_total`   decimal(10,2),
`discount_total`   decimal(10,2),
`customer_user`   varchar(10),
`cart_discount`   decimal(10,2),
`order_discount`   decimal(10,2),
`order_total`   decimal(10,2),
`payment_method`   varchar(50),
`payment_method_title`   varchar(50),
`customer_email`   varchar(50),
`billing_first_name`   varchar(50),
`billing_last_name`   varchar(50),
`billing_company`   varchar(50),
`billing_address_1`   varchar(100),
`billing_address_2`   varchar(100),
`billing_city`   varchar(100),
`billing_state`   varchar(100),
`billing_postcode`   varchar(50),
`billing_country`   varchar(50),
`billing_email`   varchar(50),
`billing_phone`   varchar(20),
`shipping_first_name`   varchar(50),
`shipping_last_name`   varchar(50),
`shipping_company`   varchar(50),
`shipping_address_1`   varchar(100),
`shipping_address_2`   varchar(100),
`shipping_city`   varchar(100),
`shipping_state`   varchar(100),
`shipping_postcode`   varchar(50),
`shipping_country`   varchar(50),
`shipping_method`   varchar(50),
`shipping_method_title`   varchar(50),
`download_permissions_granted`   varchar(10),
`download_permissions`   varchar(10),
`order_tax`   decimal(10,2),
`order_shipping_tax`   decimal(10,2),
`recorded_sales`   varchar(10),
`created_via`   varchar(20),
`cart_discount_tax`   decimal(10,2),
`order_version`   varchar(10),
`billing_address_index`   varchar(200),
`shipping_address_index`   varchar(200),
`edit_last`   varchar(50),
`date_completed`   varchar(50),
`date_paid`   varchar(50),
`paid_date`   datetime,
`completed_date`   datetime,
`recorded_coupon_usage_counts`   varchar(10),
`order_stock_reduced`   varchar(10),
`customer_ip_address`   varchar(50),
`customer_user_agent`   varchar(150),
`cart_hash`   varchar(150),
`is_vat_exempt`   varchar(10),
`order_item_name`   varchar(100) NOT NULL,
`order_item_type`   varchar(50) NOT NULL DEFAULT '',
`order_item_id`   int(20) unsigned NOT NULL,
`product_id`   int(10),
`variation_id`   int(10),
`qty`   decimal(10,2),
`tax_class`   varchar(30),
`line_subtotal`   decimal(10,2),
`line_subtotal_tax`   decimal(10,2),
`line_total`   decimal(10,2),
`line_tax`   decimal(10,2),
`line_tax_data`   longtext,
`method_id`   varchar(30),
`instance_id`   varchar(20),
`cost`   decimal(10,2),
`total_tax`   decimal(10,2),
`taxes`   decimal(10,2),
`Items`   varchar(20),
`rate_id`   varchar(20),
`label`   varchar(20),
`compound`   varchar(20),
`tax_amount`   decimal(10,2),
`shipping_tax_amount`   decimal(10,2),
`discount_amount`   decimal(10,2),
`product_created`    datetime,
`product_status`    varchar(20),
`product_type`    varchar(30),
`product_visibility`    varchar(30),
`product_cat`    varchar(50),
`product_tag`    varchar(50),
`pa_color`    varchar(20),
`pa_size`    varchar(20),
`sku`    varchar(20),
`total_sales`  decimal(10,2),
`tax_status`  varchar(10),
`manage_stock`  varchar(10),
`backorders`  varchar(10),
`sold_individually`  varchar(10),
`downloadable`  varchar(10),
`download_limit`  int(10),
`download_expiry`  int(10),
`stock`  decimal(10,2),
`stock_status`  varchar(10),
`wc_average_rating`  decimal(10,2),
`wc_review_count`  int(10),
`product_version`  varchar(10),
`price`  decimal(10,2),
`wpcom_is_markdown`  varchar(10),
`length`  decimal(10,2),
`width`  decimal(10,2),
`height`  decimal(10,2),
`regular_price`  decimal(10,2),
`sale_price`  decimal(10,2),
`wc_cog_item_cost`  decimal(10,2),
`wc_cog_item_total_cost`  decimal(10,2),
`is_deposit`  varchar(20),
`deposit_full_amount`  decimal(10,2),
`deposit_remaining_balance_paid`  decimal(10,2),
`deposit_full_amount_ex_tax`  decimal(10,2),
`deposit_deposit_amount_ex_tax`  decimal(10,2),
`weight`  decimal(10,2),
`min_variation_price`  decimal(10,2),
`max_variation_price`  decimal(10,2),
`min_variation_regular_price`  decimal(10,2),
`max_variation_regular_price`  decimal(10,2),
`min_variation_sale_price`  decimal(10,2),
`max_variation_sale_price`  decimal(10,2),
`min_variation_period`  decimal(10,2),
`max_variation_period`  decimal(10,2),
`min_variation_period_interval`  decimal(10,2),
`max_variation_period_interval`  decimal(10,2),
`subscription_price`  decimal(10,2),
`subscription_period`  decimal(10,2),
`subscription_period_interval`  decimal(10,2),
`subscription_sign_up_fee`  decimal(10,2),
`subscription_trial_period`  decimal(10,2),
`subscription_trial_length`  decimal(10,2),
`subscription_length`  decimal(10,2),
`subscription_limit`  decimal(10,2),
`wc_cog_cost_variable`  decimal(10,2),
`wc_cog_cost`  decimal(10,2),
`wc_cog_min_variation_cost`  decimal(10,2),
`wc_cog_max_variation_cost`  decimal(10,2),
`wc_cog_default_cost`  decimal(10,2),
`subscription_one_time_shipping`  decimal(10,2),
`wc_deposit_enabled`  varchar(20),
`wc_deposit_type`  varchar(20),
`wc_deposit_amount`  decimal(10,2),
`wc_deposit_payment_plans`  varchar(20),
`wc_deposit_selected_type`  varchar(20),
`wc_deposit_mult_cost_persons`  varchar(20),
`subscription_payment_sync_date`  varchar(20),
`sale_price_dates_from`  varchar(20),
`sale_price_dates_to`  varchar(20),
`product_brand`  varchar(100),
  UNIQUE KEY `idx_ic_woo_full_details_mv_order_id_order_item_id` (`order_id`,`order_item_id`),
  KEY `idx_ic_woo_full_details_mv_order_modified_date` (`order_modified_date`),
  KEY `idx_ic_woo_full_details_mv_order_date_order_status` (`order_date`,`order_status`)
);



CREATE or replace
VIEW `ic_woo_order_details_v` AS
    SELECT 
        icomv.`order_id` AS `order_id`,
        icomv.`order_date` AS `order_date`,
        icomv.`order_status` AS `order_status`,
        icomv.`post_order_number` AS `post_order_number`,
        icomv.`order_key` AS `order_key`,
        icomv.`order_currency` AS `order_currency`,
        icomv.`prices_include_tax` AS `prices_include_tax`,
        icomv.`order_number` AS `order_number`,
        icomv.`order_shipping` AS `order_shipping`,
        icomv.`fee_total` AS `fee_total`,
        icomv.`fee_tax_total` AS `fee_tax_total`,
        icomv.`discount_total` AS `discount_total`,
        icomv.`customer_user` AS `customer_user`,
        icomv.`cart_discount` AS `cart_discount`,
        icomv.`order_discount` AS `order_discount`,
        icomv.`order_total` AS `order_total`,
        icomv.`payment_method` AS `payment_method`,
        icomv.`payment_method_title` AS `payment_method_title`,
        icomv.`customer_email` AS `customer_email`,
        icomv.`billing_first_name` AS `billing_first_name`,
        icomv.`billing_last_name` AS `billing_last_name`,
        icomv.`billing_company` AS `billing_company`,
        icomv.`billing_address_1` AS `billing_address_1`,
        icomv.`billing_address_2` AS `billing_address_2`,
        icomv.`billing_city` AS `billing_city`,
        icomv.`billing_state` AS `billing_state`,
        icomv.`billing_postcode` AS `billing_postcode`,
        icomv.`billing_country` AS `billing_country`,
        icomv.`billing_email` AS `billing_email`,
        icomv.`billing_phone` AS `billing_phone`,
        icomv.`shipping_first_name` AS `shipping_first_name`,
        icomv.`shipping_last_name` AS `shipping_last_name`,
        icomv.`shipping_company` AS `shipping_company`,
        icomv.`shipping_address_1` AS `shipping_address_1`,
        icomv.`shipping_address_2` AS `shipping_address_2`,
        icomv.`shipping_city` AS `shipping_city`,
        icomv.`shipping_state` AS `shipping_state`,
        icomv.`shipping_postcode` AS `shipping_postcode`,
        icomv.`shipping_country` AS `shipping_country`,
        icomv.`shipping_method` AS `shipping_method`,
        icomv.`shipping_method_title` AS `shipping_method_title`,
        icomv.`download_permissions_granted` AS `download_permissions_granted`,
        icomv.`download_permissions` AS `download_permissions`,
        icomv.`order_tax` AS `order_tax`,
        icomv.`order_shipping_tax` AS `order_shipping_tax`,
        icomv.`recorded_sales` AS `recorded_sales`,
        icomv.`created_via` AS `created_via`,
        icomv.`cart_discount_tax` AS `cart_discount_tax`,
        icomv.`order_version` AS `order_version`,
        icomv.`billing_address_index` AS `billing_address_index`,
        icomv.`shipping_address_index` AS `shipping_address_index`,
        icomv.`edit_last` AS `edit_last`,
        icomv.`date_completed` AS `date_completed`,
        icomv.`date_paid` AS `date_paid`,
        icomv.`paid_date` AS `paid_date`,
        icomv.`completed_date` AS `completed_date`,
        icomv.`recorded_coupon_usage_counts` AS `recorded_coupon_usage_counts`,
        icomv.`order_stock_reduced` AS `order_stock_reduced`,
        icomv.`customer_ip_address` AS `customer_ip_address`,
        icomv.`customer_user_agent` AS `customer_user_agent`,
        icomv.`cart_hash` AS `cart_hash`,
        icomv.`is_vat_exempt` AS `is_vat_exempt`
    FROM
        `ic_woo_orders_mv` icomv
;


DROP PROCEDURE IF EXISTS ic_woo_daily_load;


CREATE PROCEDURE `ic_woo_daily_load`(IN p_start_date varchar(20),IN p_end_date varchar(20),IN p_load_type varchar(30))
this_proc:BEGIN
DECLARE l_last_run_date date ;
DECLARE l_start_date datetime ;
DECLARE l_end_date datetime ;
DECLARE l_job_status varchar(30);
DECLARE l_load_status varchar(30);
DECLARE l_incremental_duration INT DEFAULT 30;
DECLARE l_done INT DEFAULT 0;

/*
Fetch the job details for the load type WOO_UI_LOAD or WOO_TABLE_SYNC
*/
    DEClARE cur_get_run_date
        CURSOR FOR 
            SELECT date(last_run_date),load_status,incremental_duration FROM xjob
			where job_name = p_load_type
            and job_type = 'mysql_stored_call';
            
	DECLARE CONTINUE HANDLER FOR NOT FOUND SET l_done = 1;            

    OPEN cur_get_run_date;
    FETCH cur_get_run_date INTO l_last_run_date,l_load_status,l_incremental_duration;
    CLOSE cur_get_run_date;



/*
Do not proceed if UI load and it is already marked as complete
*/

IF (p_load_type='WOO_UI_LOAD' AND l_load_status='complete') THEN
	select x.*
	,date(last_run_date) load_from_date
	,date(date_add(last_run_date,INTERVAL incremental_duration DAY)) load_to_date 
	from xjob x 
	where x.job_name = p_load_type
    and x.job_type = 'mysql_stored_call';
	
	LEAVE this_proc;
END IF;


IF (p_start_date IS NULL OR p_start_date='null') THEN
  SET l_start_date=l_last_run_date;
ELSE
  SET l_start_date=str_to_date(p_start_date,'%Y-%m-%d');

END IF;

IF (p_end_date IS NULL OR p_end_date='null') THEN
  
  IF p_load_type='WOO_UI_LOAD' THEN
     SET l_end_date=DATE_ADD(l_last_run_date, INTERVAL l_incremental_duration DAY);
     
  ELSE
  
	SET l_end_date=DATE_ADD(greatest(l_last_run_date,curdate()), INTERVAL 1 DAY);
  END IF;

ELSE
  SET l_end_date=str_to_date(concat(p_end_date,' 23:59:59'),'%Y-%m-%d %H:%i:%s');
END IF;

   


INSERT INTO ic_woo_orders_mv(
order_id,order_date,order_status,post_order_number,order_modified_date,order_key,order_currency,prices_include_tax
,order_number,order_shipping,fee_total,fee_tax_total,discount_total,customer_user,cart_discount,order_discount
,order_total,payment_method,payment_method_title,customer_email,billing_first_name,billing_last_name,billing_company
,billing_address_1,billing_address_2,billing_city,billing_state,billing_postcode,billing_country,billing_email
,billing_phone,shipping_first_name,shipping_last_name,shipping_company,shipping_address_1,shipping_address_2
,shipping_city,shipping_state,shipping_postcode,shipping_country,shipping_method,shipping_method_title,download_permissions_granted
,download_permissions,order_tax,order_shipping_tax,recorded_sales,created_via,cart_discount_tax,order_version
,billing_address_index,shipping_address_index,edit_last,date_completed,date_paid,paid_date,completed_date
,recorded_coupon_usage_counts,order_stock_reduced,customer_ip_address,customer_user_agent,cart_hash,is_vat_exempt
,wc_cog_order_total_cost,is_deposit_order
)
SELECT 
iwom.order_id,iwom.order_date,iwom.order_status,iwom.post_order_number,iwom.order_modified_date,iwom.order_key
,iwom.order_currency,iwom.prices_include_tax,iwom.order_number,iwom.order_shipping,iwom.fee_total,iwom.fee_tax_total
,iwom.discount_total,iwom.customer_user,iwom.cart_discount,iwom.order_discount,iwom.order_total,iwom.payment_method
,iwom.payment_method_title,iwom.customer_email,iwom.billing_first_name,iwom.billing_last_name,iwom.billing_company
,iwom.billing_address_1,iwom.billing_address_2,iwom.billing_city,iwom.billing_state,iwom.billing_postcode,iwom.billing_country
,iwom.billing_email,iwom.billing_phone,iwom.shipping_first_name,iwom.shipping_last_name,iwom.shipping_company
,iwom.shipping_address_1,iwom.shipping_address_2,iwom.shipping_city,iwom.shipping_state,iwom.shipping_postcode,iwom.shipping_country
,iwom.shipping_method,iwom.shipping_method_title,iwom.download_permissions_granted,iwom.download_permissions
,iwom.order_tax,iwom.order_shipping_tax,iwom.recorded_sales,iwom.created_via,iwom.cart_discount_tax,iwom.order_version
,iwom.billing_address_index,iwom.shipping_address_index,iwom.edit_last,iwom.date_completed,iwom.date_paid,iwom.paid_date
,iwom.completed_date,iwom.recorded_coupon_usage_counts,iwom.order_stock_reduced,iwom.customer_ip_address,iwom.customer_user_agent
,iwom.cart_hash,iwom.is_vat_exempt,iwom.wc_cog_order_total_cost,iwom.is_deposit_order
FROM ic_woo_orders_v iwom 
WHERE iwom.order_modified_date >= l_start_date and iwom.order_date <= l_end_date
ON DUPLICATE KEY UPDATE 
order_date = iwom.order_date,
order_status = iwom.order_status,
post_order_number = iwom.post_order_number,
order_modified_date = iwom.order_modified_date,
order_key = iwom.order_key,
order_currency = iwom.order_currency,
prices_include_tax = iwom.prices_include_tax,
order_number = iwom.order_number,
order_shipping = iwom.order_shipping,
fee_total = iwom.fee_total,
fee_tax_total = iwom.fee_tax_total,
discount_total = iwom.discount_total,
customer_user = iwom.customer_user,
cart_discount = iwom.cart_discount,
order_discount = iwom.order_discount,
order_total = iwom.order_total,
payment_method = iwom.payment_method,
payment_method_title = iwom.payment_method_title,
customer_email = iwom.customer_email,
billing_first_name = iwom.billing_first_name,
billing_last_name = iwom.billing_last_name,
billing_company = iwom.billing_company,
billing_address_1 = iwom.billing_address_1,
billing_address_2 = iwom.billing_address_2,
billing_city = iwom.billing_city,
billing_state = iwom.billing_state,
billing_postcode = iwom.billing_postcode,
billing_country = iwom.billing_country,
billing_email = iwom.billing_email,
billing_phone = iwom.billing_phone,
shipping_first_name = iwom.shipping_first_name,
shipping_last_name = iwom.shipping_last_name,
shipping_company = iwom.shipping_company,
shipping_address_1 = iwom.shipping_address_1,
shipping_address_2 = iwom.shipping_address_2,
shipping_city = iwom.shipping_city,
shipping_state = iwom.shipping_state,
shipping_postcode = iwom.shipping_postcode,
shipping_country = iwom.shipping_country,
shipping_method = iwom.shipping_method,
shipping_method_title = iwom.shipping_method_title,
download_permissions_granted = iwom.download_permissions_granted,
download_permissions = iwom.download_permissions,
order_tax = iwom.order_tax,
order_shipping_tax = iwom.order_shipping_tax,
recorded_sales = iwom.recorded_sales,
created_via = iwom.created_via,
cart_discount_tax = iwom.cart_discount_tax,
order_version = iwom.order_version,
billing_address_index = iwom.billing_address_index,
shipping_address_index = iwom.shipping_address_index,
edit_last = iwom.edit_last,
date_completed = iwom.date_completed,
date_paid = iwom.date_paid,
paid_date = iwom.paid_date,
completed_date = iwom.completed_date,
recorded_coupon_usage_counts = iwom.recorded_coupon_usage_counts,
order_stock_reduced = iwom.order_stock_reduced,
customer_ip_address = iwom.customer_ip_address,
customer_user_agent = iwom.customer_user_agent,
cart_hash = iwom.cart_hash,
is_vat_exempt = iwom.is_vat_exempt,
wc_cog_order_total_cost = iwom.wc_cog_order_total_cost,
is_deposit_order = iwom.is_deposit_order;

INSERT INTO ic_woo_full_details_mv(
order_id,order_date,order_modified_date,order_status,post_order_number,order_key,order_currency,prices_include_tax
,order_number,order_shipping,fee_total,fee_tax_total,discount_total,customer_user,cart_discount,order_discount,order_total
,payment_method,payment_method_title,customer_email,billing_first_name,billing_last_name,billing_company,billing_address_1
,billing_address_2,billing_city,billing_state,billing_postcode,billing_country,billing_email,billing_phone,shipping_first_name
,shipping_last_name,shipping_company,shipping_address_1,shipping_address_2,shipping_city,shipping_state,shipping_postcode
,shipping_country,shipping_method,shipping_method_title,download_permissions_granted,download_permissions,order_tax,order_shipping_tax
,recorded_sales,created_via,cart_discount_tax,order_version,billing_address_index,shipping_address_index,edit_last,date_completed
,date_paid,paid_date,completed_date,recorded_coupon_usage_counts,order_stock_reduced,customer_ip_address,customer_user_agent
,cart_hash,is_vat_exempt,order_item_name,order_item_type,order_item_id,product_id,variation_id,qty,tax_class,line_subtotal
,line_subtotal_tax,line_total,line_tax,line_tax_data,method_id,instance_id,cost,total_tax,taxes,Items,rate_id,label,compound
,tax_amount,shipping_tax_amount,discount_amount,product_created,product_status,product_type,product_visibility,product_cat
,product_tag,pa_color,pa_size,sku,total_sales,tax_status,manage_stock,backorders,sold_individually,downloadable,download_limit
,download_expiry,stock,stock_status,wc_average_rating,wc_review_count,product_version,price,wpcom_is_markdown,length,width,height
,regular_price,sale_price,wc_cog_item_cost,wc_cog_item_total_cost        ,is_deposit,deposit_full_amount,deposit_remaining_balance_paid
,deposit_full_amount_ex_tax,deposit_deposit_amount_ex_tax,weight,min_variation_price,max_variation_price,min_variation_regular_price
,max_variation_regular_price,min_variation_sale_price,max_variation_sale_price,min_variation_period,max_variation_period
,min_variation_period_interval,max_variation_period_interval,subscription_price,subscription_period,subscription_period_interval
,subscription_sign_up_fee,subscription_trial_period,subscription_trial_length,subscription_length,subscription_limit
,wc_cog_cost_variable,wc_cog_cost,wc_cog_min_variation_cost,wc_cog_max_variation_cost,wc_cog_default_cost,subscription_one_time_shipping
,wc_deposit_enabled,wc_deposit_type,wc_deposit_amount,wc_deposit_payment_plans,wc_deposit_selected_type,wc_deposit_mult_cost_persons
,subscription_payment_sync_date,sale_price_dates_from,sale_price_dates_to,product_brand
)
SELECT 
iwfd.order_id,iwfd.order_date,iwfd.order_modified_date,iwfd.order_status,iwfd.post_order_number,iwfd.order_key,iwfd.order_currency
,iwfd.prices_include_tax,iwfd.order_number,iwfd.order_shipping,iwfd.fee_total,iwfd.fee_tax_total,iwfd.discount_total,iwfd.customer_user
,iwfd.cart_discount,iwfd.order_discount,iwfd.order_total,iwfd.payment_method,iwfd.payment_method_title,iwfd.customer_email
,iwfd.billing_first_name,iwfd.billing_last_name,iwfd.billing_company,iwfd.billing_address_1,iwfd.billing_address_2,iwfd.billing_city
,iwfd.billing_state,iwfd.billing_postcode,iwfd.billing_country,iwfd.billing_email,iwfd.billing_phone,iwfd.shipping_first_name
,iwfd.shipping_last_name,iwfd.shipping_company,iwfd.shipping_address_1,iwfd.shipping_address_2,iwfd.shipping_city,iwfd.shipping_state
,iwfd.shipping_postcode,iwfd.shipping_country,iwfd.shipping_method,iwfd.shipping_method_title,iwfd.download_permissions_granted
,iwfd.download_permissions,iwfd.order_tax,iwfd.order_shipping_tax,iwfd.recorded_sales,iwfd.created_via,iwfd.cart_discount_tax
,iwfd.order_version,iwfd.billing_address_index,iwfd.shipping_address_index,iwfd.edit_last,iwfd.date_completed,iwfd.date_paid,iwfd.paid_date
,iwfd.completed_date,iwfd.recorded_coupon_usage_counts,iwfd.order_stock_reduced,iwfd.customer_ip_address,iwfd.customer_user_agent
,iwfd.cart_hash,iwfd.is_vat_exempt,iwfd.order_item_name,iwfd.order_item_type,iwfd.order_item_id,iwfd.product_id,iwfd.variation_id
,iwfd.qty,iwfd.tax_class,iwfd.line_subtotal,iwfd.line_subtotal_tax,iwfd.line_total,iwfd.line_tax,iwfd.line_tax_data,iwfd.method_id
,iwfd.instance_id,iwfd.cost,iwfd.total_tax,iwfd.taxes,iwfd.Items,iwfd.rate_id,iwfd.label,iwfd.compound,iwfd.tax_amount
,iwfd.shipping_tax_amount,iwfd.discount_amount,iwfd.product_created,iwfd.product_status,iwfd.product_type,iwfd.product_visibility
,iwfd.product_cat,iwfd.product_tag,iwfd.pa_color,iwfd.pa_size,iwfd.sku,iwfd.total_sales,iwfd.tax_status,iwfd.manage_stock,iwfd.backorders
,iwfd.sold_individually,iwfd.downloadable,iwfd.download_limit,iwfd.download_expiry,iwfd.stock,iwfd.stock_status,iwfd.wc_average_rating
,iwfd.wc_review_count,iwfd.product_version,iwfd.price,iwfd.wpcom_is_markdown,iwfd.length,iwfd.width,iwfd.height,iwfd.regular_price
,iwfd.sale_price,iwfd.wc_cog_item_cost,iwfd.wc_cog_item_total_cost        ,iwfd.is_deposit,iwfd.deposit_full_amount
,iwfd.deposit_remaining_balance_paid,iwfd.deposit_full_amount_ex_tax,iwfd.deposit_deposit_amount_ex_tax,iwfd.weight,iwfd.min_variation_price
,iwfd.max_variation_price,iwfd.min_variation_regular_price,iwfd.max_variation_regular_price,iwfd.min_variation_sale_price
,iwfd.max_variation_sale_price,iwfd.min_variation_period,iwfd.max_variation_period,iwfd.min_variation_period_interval
,iwfd.max_variation_period_interval,iwfd.subscription_price,iwfd.subscription_period,iwfd.subscription_period_interval
,iwfd.subscription_sign_up_fee,iwfd.subscription_trial_period,iwfd.subscription_trial_length,iwfd.subscription_length
,iwfd.subscription_limit,iwfd.wc_cog_cost_variable,iwfd.wc_cog_cost,iwfd.wc_cog_min_variation_cost,iwfd.wc_cog_max_variation_cost
,iwfd.wc_cog_default_cost,iwfd.subscription_one_time_shipping,iwfd.wc_deposit_enabled,iwfd.wc_deposit_type,iwfd.wc_deposit_amount
,iwfd.wc_deposit_payment_plans,iwfd.wc_deposit_selected_type,iwfd.wc_deposit_mult_cost_persons,iwfd.subscription_payment_sync_date
,iwfd.sale_price_dates_from,iwfd.sale_price_dates_to,product_brand
FROM ic_woo_full_details_v iwfd 
WHERE iwfd.order_modified_date >= l_start_date and iwfd.order_date <= l_end_date
ON DUPLICATE KEY UPDATE 
order_date = iwfd.order_date,
order_modified_date = iwfd.order_modified_date,
order_status = iwfd.order_status,
post_order_number = iwfd.post_order_number,
order_key = iwfd.order_key,
order_currency = iwfd.order_currency,
prices_include_tax = iwfd.prices_include_tax,
order_number = iwfd.order_number,
order_shipping = iwfd.order_shipping,
fee_total = iwfd.fee_total,
fee_tax_total = iwfd.fee_tax_total,
discount_total = iwfd.discount_total,
customer_user = iwfd.customer_user,
cart_discount = iwfd.cart_discount,
order_discount = iwfd.order_discount,
order_total = iwfd.order_total,
payment_method = iwfd.payment_method,
payment_method_title = iwfd.payment_method_title,
customer_email = iwfd.customer_email,
billing_first_name = iwfd.billing_first_name,
billing_last_name = iwfd.billing_last_name,
billing_company = iwfd.billing_company,
billing_address_1 = iwfd.billing_address_1,
billing_address_2 = iwfd.billing_address_2,
billing_city = iwfd.billing_city,
billing_state = iwfd.billing_state,
billing_postcode = iwfd.billing_postcode,
billing_country = iwfd.billing_country,
billing_email = iwfd.billing_email,
billing_phone = iwfd.billing_phone,
shipping_first_name = iwfd.shipping_first_name,
shipping_last_name = iwfd.shipping_last_name,
shipping_company = iwfd.shipping_company,
shipping_address_1 = iwfd.shipping_address_1,
shipping_address_2 = iwfd.shipping_address_2,
shipping_city = iwfd.shipping_city,
shipping_state = iwfd.shipping_state,
shipping_postcode = iwfd.shipping_postcode,
shipping_country = iwfd.shipping_country,
shipping_method = iwfd.shipping_method,
shipping_method_title = iwfd.shipping_method_title,
download_permissions_granted = iwfd.download_permissions_granted,
download_permissions = iwfd.download_permissions,
order_tax = iwfd.order_tax,
order_shipping_tax = iwfd.order_shipping_tax,
recorded_sales = iwfd.recorded_sales,
created_via = iwfd.created_via,
cart_discount_tax = iwfd.cart_discount_tax,
order_version = iwfd.order_version,
billing_address_index = iwfd.billing_address_index,
shipping_address_index = iwfd.shipping_address_index,
edit_last = iwfd.edit_last,
date_completed = iwfd.date_completed,
date_paid = iwfd.date_paid,
paid_date = iwfd.paid_date,
completed_date = iwfd.completed_date,
recorded_coupon_usage_counts = iwfd.recorded_coupon_usage_counts,
order_stock_reduced = iwfd.order_stock_reduced,
customer_ip_address = iwfd.customer_ip_address,
customer_user_agent = iwfd.customer_user_agent,
cart_hash = iwfd.cart_hash,
is_vat_exempt = iwfd.is_vat_exempt,
order_item_name = iwfd.order_item_name,
order_item_type = iwfd.order_item_type,
order_item_id = iwfd.order_item_id,
product_id = iwfd.product_id,
variation_id = iwfd.variation_id,
qty = iwfd.qty,
tax_class = iwfd.tax_class,
line_subtotal = iwfd.line_subtotal,
line_subtotal_tax = iwfd.line_subtotal_tax,
line_total = iwfd.line_total,
line_tax = iwfd.line_tax,
line_tax_data = iwfd.line_tax_data,
method_id = iwfd.method_id,
instance_id = iwfd.instance_id,
cost = iwfd.cost,
total_tax = iwfd.total_tax,
taxes = iwfd.taxes,
Items = iwfd.Items,
rate_id = iwfd.rate_id,
label = iwfd.label,
compound = iwfd.compound,
tax_amount = iwfd.tax_amount,
shipping_tax_amount = iwfd.shipping_tax_amount,
discount_amount = iwfd.discount_amount,
product_created = iwfd.product_created,
product_status = iwfd.product_status,
product_type = iwfd.product_type,
product_visibility = iwfd.product_visibility,
product_cat = iwfd.product_cat,
product_tag = iwfd.product_tag,
pa_color = iwfd.pa_color,
pa_size = iwfd.pa_size,
sku = iwfd.sku,
total_sales = iwfd.total_sales,
tax_status = iwfd.tax_status,
manage_stock = iwfd.manage_stock,
backorders = iwfd.backorders,
sold_individually = iwfd.sold_individually,
downloadable = iwfd.downloadable,
download_limit = iwfd.download_limit,
download_expiry = iwfd.download_expiry,
stock = iwfd.stock,
stock_status = iwfd.stock_status,
wc_average_rating = iwfd.wc_average_rating,
wc_review_count = iwfd.wc_review_count,
product_version = iwfd.product_version,
price = iwfd.price,
wpcom_is_markdown = iwfd.wpcom_is_markdown,
length = iwfd.length,
width = iwfd.width,
height = iwfd.height,
regular_price = iwfd.regular_price,
sale_price = iwfd.sale_price,
wc_cog_item_cost = iwfd.wc_cog_item_cost,
wc_cog_item_total_cost         = iwfd.wc_cog_item_total_cost        ,
is_deposit = iwfd.is_deposit,
deposit_full_amount = iwfd.deposit_full_amount,
deposit_remaining_balance_paid = iwfd.deposit_remaining_balance_paid,
deposit_full_amount_ex_tax = iwfd.deposit_full_amount_ex_tax,
deposit_deposit_amount_ex_tax = iwfd.deposit_deposit_amount_ex_tax,
weight = iwfd.weight,
min_variation_price = iwfd.min_variation_price,
max_variation_price = iwfd.max_variation_price,
min_variation_regular_price = iwfd.min_variation_regular_price,
max_variation_regular_price = iwfd.max_variation_regular_price,
min_variation_sale_price = iwfd.min_variation_sale_price,
max_variation_sale_price = iwfd.max_variation_sale_price,
min_variation_period = iwfd.min_variation_period,
max_variation_period = iwfd.max_variation_period,
min_variation_period_interval = iwfd.min_variation_period_interval,
max_variation_period_interval = iwfd.max_variation_period_interval,
subscription_price = iwfd.subscription_price,
subscription_period = iwfd.subscription_period,
subscription_period_interval = iwfd.subscription_period_interval,
subscription_sign_up_fee = iwfd.subscription_sign_up_fee,
subscription_trial_period = iwfd.subscription_trial_period,
subscription_trial_length = iwfd.subscription_trial_length,
subscription_length = iwfd.subscription_length,
subscription_limit = iwfd.subscription_limit,
wc_cog_cost_variable = iwfd.wc_cog_cost_variable,
wc_cog_cost = iwfd.wc_cog_cost,
wc_cog_min_variation_cost = iwfd.wc_cog_min_variation_cost,
wc_cog_max_variation_cost = iwfd.wc_cog_max_variation_cost,
wc_cog_default_cost = iwfd.wc_cog_default_cost,
subscription_one_time_shipping = iwfd.subscription_one_time_shipping,
wc_deposit_enabled = iwfd.wc_deposit_enabled,
wc_deposit_type = iwfd.wc_deposit_type,
wc_deposit_amount = iwfd.wc_deposit_amount,
wc_deposit_payment_plans = iwfd.wc_deposit_payment_plans,
wc_deposit_selected_type = iwfd.wc_deposit_selected_type,
wc_deposit_mult_cost_persons = iwfd.wc_deposit_mult_cost_persons,
subscription_payment_sync_date = iwfd.subscription_payment_sync_date,
sale_price_dates_from = iwfd.sale_price_dates_from,
sale_price_dates_to = iwfd.sale_price_dates_to,
product_brand=iwfd.product_brand;


IF p_load_type='WOO_TABLE_SYNC' THEN
	update xjob
	set last_run_date=curdate()
	, last_update_date=now()
    , last_run_rows= found_rows()
	where job_name='WOO_TABLE_SYNC'
	and job_type='mysql_stored_call';

ELSE

/*
for WOO_UI_LOAD, if the end_date happens to cross today's date then mark it complete
*/
   IF ( l_end_date>now() ) THEN
     SET l_job_status='complete';
   ELSE  
     SET l_job_status='in progress';
   END IF;
   
	update xjob
	set last_run_date=l_end_date
	, last_update_date=now()
    , last_run_rows= found_rows()
    , load_status=l_job_status
	where job_name='WOO_UI_LOAD'
	and job_type='mysql_stored_call';

END IF;


	select x.*
	,date(last_run_date) load_from_date
	,date(date_add(last_run_date,INTERVAL incremental_duration DAY)) load_to_date 
	from xjob x 
	where x.job_name = p_load_type
    and x.job_type = 'mysql_stored_call';   

END
;


insert into {$wp_prefix}options(option_name,option_value) values
('icdash_woo_core_seedata','Y')
ON DUPLICATE KEY UPDATE 
option_value = 'Y';





drop table IF EXISTS ic_woo_lookup_t;





CREATE TABLE `ic_woo_lookup_t` (
`lookup_type`   varchar(20) ,	
`lookup_name`   varchar(20),	
`lookup_value`   varchar(150), 	
  UNIQUE KEY `idx_ic_woo_lookup_t` (`lookup_type`,`lookup_name` ,`lookup_value`)
)
;


insert into ic_woo_lookup_t(lookup_type,lookup_name,lookup_value) 
SELECT distinct 'order_status', upper(replace(post_status,'wc-','')),post_status 
FROM `{$wp_prefix}posts` 
where post_status like 'wc%'
;



