<?php

//include_once dirname(__FILE__)."/xmember_api.php";
//include_once dirname(__FILE__)."/xmember_public_fn.php";

include_once dirname(__FILE__)."/system/property_definition.php";
include_once dirname(__FILE__)."/system/general.php";
include_once dirname(__FILE__)."/social_logfn.php";

ini_set("session.gc_maxlifetime", "172800");
date_default_timezone_set('America/New_York');
$db=null; //global db connection variable


function xi_initSession()
{
session_start();
if(!isset($_SESSION['xmember']['username']) && $_SESSION['xmember']['login_validated']!='YES')
{
  return false;
}

return true;

}

function xi_getUser()
{
	return $_SESSION['xmember']['username'];
}

function xi_getUserID()
{
  return $_SESSION['xmember']["user_id"];
}

function xi_getUserDir()
{
global $property;

	$user=xi_getUser();
	return dirname(__FILE__)."/{$property['data_dir']}/{$user}";
}

function xi_getDataDir()
{
global $property;

return "{$property['data_dir']}/";

}

function xi_logoutUser(){
	zlog(0,$_SESSION['xmember']['username'],"xi_logoutUser initiated >> " .$_SESSION['xmember']["username"]);
	session_destroy();
	session_unset();
	$_SESSION = array();
//unset($_SESSION['xmember']["username"]);
}

function xi_getBaseDir()
{
return dirname(__FILE__);
}

function xi_getBaseURL()
{
	$httpStr="http";
	$port="";
	if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') $httpStr="https";
	if (isset($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT']!="80") $port=":".$_SERVER['SERVER_PORT'];
	$base_server="{$httpStr}://{$_SERVER['SERVER_NAME']}{$port}";
	return $base_server;
}

function xi_getUrlDir()
{
	return dirname($_SERVER['SCRIPT_NAME']);
}

function xi_getAppUrlBase()
{
  return xi_getBaseURL().xi_getUrlDir();
}

function xi_getAppScriptUrl()
{
  return xi_getBaseURL().$_SERVER['SCRIPT_NAME'];
}

//Database for the infocaptor repository
function xi_getConnection()
{
//global $xapi_fn;
//return $xapi_fn["_Xget_repo_connection"];

global $db;
global $property;

if (isset($db))
   {

		return $db;
	}

    zlog(5,$_SESSION['xmember']['username'],"xmember_api.get_connection() start");
    try
    {
		$xconnection_name = "repository";
		$db_config_file = dirname(__FILE__)."/".$property['dbconfig_location'];


		if (file_exists($db_config_file) ) include($db_config_file);
		else {zlog(0,$_SESSION['xmember']['username'],"db config is missing..probably a fresh install");return;}

		zlog(3,$_SESSION['xmember']['username'],"xmember_api.connection db_array".print_r($xdb_array,true));
		//echo "type--".$xdb_array[$xconnection_name]['type'];

		
		$cnnt_str="mysql:host={$xdb_array[$xconnection_name]['host']};port={$xdb_array[$xconnection_name]['port']};dbname={$xdb_array[$xconnection_name]['name']}";
		zlog(3,$_SESSION['xmember']['username'],$cnnt_str);
		$db = new PDO($cnnt_str, $xdb_array[$xconnection_name]['user'], $xdb_array[$xconnection_name]['pass']);
		$db->setAttribute( PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION );
		
		if (!$db)
		{
			zlog(-1,$_SESSION['xmember']['username'],"xmember_api.init() cannot connect to member database");
			
			return false;
		}
		else
		{    
			zlog(3,$_SESSION['xmember']['username'],"connected success");
			
			return $db;
		}

		return $db;
    }
	catch (exception $e) 
	{
		zlog(-1,$_SESSION['xmember']['username'], "Database connection Error!: " . $e->getMessage() );
		return null;
    
	}

}


function xi_getArray($sql)
{
/*    zlog(0,$_SESSION['xmember']['username'],"xi_getArray() start");
    zlog(0,$_SESSION['xmember']['username'],"xi_getArray SQL=".$sql);
global $xapi_fn;


return $xapi_fn["_Xget_array"]($sql);
*/

/*
returns an array of objects
[0] is the first row and [0][job_id] is the job_id column from 1st row
e.g 
(
    [0] => Array
        (
            [job_id] => 5
            [job_name] => infocaptor_summary
            [job_type] => google_analytics
            [load_type] => incremental
            [start_date] => 2016-09-18
            [end_date] => 2016-09-19
            [load_status] => pending
		)	
*/
    zlog(5,$_SESSION['xmember']['username'],"xi_getArray() start");
    zlog(0,$_SESSION['xmember']['username'],"xi_getArray SQL=".$sql);
 try
 {

    global $xconnection_name;

    $db= xi_getConnection();
    if ($db)
    {

		$stmt=$db->query($sql);
		if ($stmt) //if success
		{
		  
			$stmt->setFetchMode(PDO::FETCH_ASSOC);
			$rows = $stmt->fetchAll();
	
			unset($stmt);
			zlog(5,$_SESSION['xmember']['username'],"get_array \n".print_r($rows,true));
			return $rows;
		}
		else
		{
		   unset($stmt);
		   $err=$db->errorInfo();
			zlog(-1,$_SESSION['xmember']['username'],"Error... {$err[0]} - {$err[1]} - {$err[2]}");

			return false;
		}	
		//$recordSet = $db->Execute($sql);
	   //$_SESSION["xmember"]["rows_affected"]=$db->Affected_Rows();

      return false;


    }
    else
        {
          zlog(-1,$_SESSION['xmember']['username'],"xmember_api.get_array error connection".$db->errorInfo());
           zlog(-1,$_SESSION['xmember']['username'],"xmember_api.get_array error connection".print_r($db,true));
           return false;
    }

  
 }
 catch( exception $e)
 {
 		zlog(-1,$_SESSION['xmember']['username'], "Error!: " . $e->getMessage() );

      
      zlog(-1,$_SESSION['xmember']['username'],"xmember_api.get_array Reference SQL=".$sql);
 }
}

function xi_getDmlResult($sql)
{
/*
global $xapi_fn;
return $xapi_fn["_Xget_dmlresult"]($sql);
*/
    zlog(5,$_SESSION['xmember']['username'],"xi_getDmlResult() start");
    zlog(0,$_SESSION['xmember']['username'],"xi_getDmlResult SQL=".$sql);
 try
 {

    
 // if ($_SESSION[$xconnection_name])
  {
    $db= xi_getConnection();
    if ($db)
    {

		$stmt = $db->prepare($sql);
		$stmt->execute();
		$count = $stmt->rowCount();
		$_SESSION["xmember"]["rows_affected"]=$count;
		zlog(0,$_SESSION['xmember']['username'],"rows affected = ".$count);		

      return $count;


    }
    else
    {
       zlog(-1,$_SESSION['xmember']['username'],"xmember_api.get_dml_result error connection".$db->errorInfo());
       zlog(-1,$_SESSION['xmember']['username'],"xmember_api.get_dml_result error connection".print_r($db,true));
       return false;
    }

  }
 }
 catch( exception $e)
 {
      zlog(-1,$_SESSION['xmember']['username'],"xmember_api.get_sql_result exception".print_r($e,true));
      zlog(-1,$_SESSION['xmember']['username'],"xmember_api.get_sql_result Reference SQL=".$sql);
	  return false;
 }
}


function xi_clean_filename($filename){
	$filename = strtolower($filename);
	//$filename = str_replace(".","_",$filename);
	$filename=preg_replace("/[^0-9a-zA-Z_\.]/","_",$filename);
	$filename=preg_replace('/\s+/', '_', $filename); //more than one space into one underscore
	$filename=preg_replace('/_+/', '_', $filename); //more than one underscore into one underscore
	$filename=preg_replace('/_$/', '', $filename); //replace underscore at the end of the string
	
	return $filename;
}

function xi_alphanum_clean($filename){
	$filename = strtolower($filename);
	$filename=preg_replace("/[^0-9a-zA-Z_]/","_",$filename);
	$filename=preg_replace('/\s+/', '_', $filename); //more than one space into one underscore
	$filename=preg_replace('/_+/', '_', $filename); //more than one underscore into one underscore
	$filename=preg_replace('/_$/', '', $filename); //replace underscore at the end of the string
	
	return $filename;
}

 
 //GET JOBS DATA
function xi_getJobsData($username)
{
	if($_SESSION['xmember']['role_id'] == 1)
		$sql="select * from xjob";
	else
		$sql="select * from xjob where username='{$username}'";
	
	$job_list = xi_getArray($sql);
	//zlog(5,$_SESSION['xmember']['username'],print_r($job_list,true));
	return $job_list;

}

 //GET JOBS DATA
function xi_getFormJobsData($form_filter)
{
$username=$_SESSION['xmember']["username"];

	if($_SESSION['xmember']['role_id'] == 1)
		$sql="select * from xjob where username like '%{$form_filter}%' or job_name  like '%{$form_filter}%' 
		or job_type like '%{$form_filter}%' or connection_handler  like '%{$form_filter}%' or tablestore  like '%{$form_filter}%'
		";
	else
		$sql="select * from xjob where username='{$username}'
		and
		(
		job_name  like '%{$form_filter}%' 
		or job_type like '%{$form_filter}%' or connection_handler  like '%{$form_filter}%' or tablestore  like '%{$form_filter}%'
		)";
	
	$job_list = xi_getArray($sql);
	//zlog(5,$_SESSION['xmember']['username'],print_r($job_list,true));
	return $job_list;
}

function xi_getJobsList($username,$job_type,$load_type,$load_status)
{
	
		$sql="select * from xjob 
		where username like '{$username}'
		and job_type like '{$job_type}'
		and load_type like '{$load_type}'
		and load_status like '{$load_status}'
		";
	
	$job_list = xi_getArray($sql);
	return $job_list;

}

function xi_add_job($username,$job_data)
{
    zlog(0,$_SESSION['xmember']['username'],"xmember_api.add_job() start");
    zlog(5,$_SESSION['xmember']['username'],"xmember_api.add_job job_array =".print_r($job_data,true));
    
	try
	{
		if($job_data['oper'] == 'add')
			unset($job_data['job_id']);

		unset($job_data['oper']);
		unset($job_data['id']);
		$job_data['username'] = $username; 
		$fields = implode(',',array_keys($job_data));
		//$escapedfieldValues = array_map(create_function('$e', 'return mysql_real_escape_string(((get_magic_quotes_gpc()) ? stripslashes($e) : $e));'), array_values($job_data));		
		$values = implode(',', array_map(function($value) {
			if(!is_numeric($value)) {
				return '"' . $value . '"';
				//adds double quotes, but if you prefer single quotes, use:
				//return "'" . $value . "'";
			} else {
				return $value;
			}
		}, array_values($job_data)));
	
		$sql="INSERT INTO xjob ($fields) values($values)";
		
		$result=xi_getDmlResult($sql);
		 $db= xi_getConnection();
		 $id=$db->lastInsertId();
		 return $id;
		//return mysql_insert_id();
		if (!$result)
		{
			zlog(-1,$_SESSION['xmember']['username'],"xmember_api.add_job insert error for [{$sql}] =");
			return false;
		}
	}
	catch (exception $e)
	{
		zlog(-1,$_SESSION['xmember']['username'],"xmember_api.add_job SQL = [{$sql}] =");
		zlog(-1,$_SESSION['xmember']['username'],"xmember_api.add_job exception =".print_r($e,true));
		return false;
	}
  return true;
} //add_job

function xi_update_job($job_data)
{
    zlog(0,$_SESSION['xmember']['username'],"xmember_api.update_job() start");
    zlog(5,$_SESSION['xmember']['username'],"xmember_api.update_job job_data =".print_r($job_data,true));

 try
 {
	 	unset($job_data['oper']);
		unset($job_data['id']);
		$values = "";
		$id = $job_data['job_id'];
		unset($job_data['job_id']);
		
		foreach($job_data as $field=>$value)
		{
			//$value = mysql_real_escape_string(((get_magic_quotes_gpc()) ? stripslashes($value) : $value));
			if(is_numeric($value) == "")
				$values .= "$field = '$value',";
			else
				$values .= "$field = $value,";
		}
		
		$values = substr($values,0,strLen($values)-1);
		
		$sql="update xjob set " . $values ." where  job_id  = ". $id;
		$result=xi_getDmlResult($sql);
		if (!$result)
		{
			zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_job insert error for [{$sql}] =");
			return false;
		}

		return true;
 }
 catch (exception $e)
 {
     zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_job SQL = [{$sql}] =");
     zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_job exception =".print_r($e,true));
     return false;
 }
  return true;
} //update job


function xi_update_job_by_id($job_id,$job_data)
{
    zlog(0,$_SESSION['xmember']['username'],"xmember_api.update_job() start");
    zlog(5,$_SESSION['xmember']['username'],"xmember_api.update_job job_data =".print_r($job_data,true));

 try
 {

		$values = "";
		$id = $job_id;

		
		foreach($job_data as $field=>$value)
		{
			//$value = mysql_real_escape_string(((get_magic_quotes_gpc()) ? stripslashes($value) : $value));
			if(is_numeric($value) == "")
				$values .= "$field = '$value',";
			else
				$values .= "$field = $value,";
		}
		
		$values = substr($values,0,strLen($values)-1);
		
		$sql="update xjob set " . $values ." where  job_id  = ". $id;
		$result=xi_getDmlResult($sql);
		if (!$result)
		{
			zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_job insert error for [{$sql}] =");
			return false;
		}

		return true;
 }
 catch (exception $e)
 {
     zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_job SQL = [{$sql}] =");
     zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_job exception =".print_r($e,true));
     return false;
 }
  return true;
} //update job

function xi_add_raw_job_data($data){
	//create unique job_id, add the record to table and return the job_id

	$fields='';
	$fields_values='';
	if(count($data)>0) {
		foreach($data as $ind => $value) {
			$fields .= $ind.',';
			$fields_values .= "'".$value."',";
		}
	}
	
	$fields = substr($fields,0,-1);
	$fields_values = substr($fields_values,0,-1);

	$sql = "INSERT INTO xjob_raw_data ({$fields}) VALUES ({$fields_values})";
		$result=xi_getDmlResult($sql);
		
		$db= xi_getConnection();
		 $id=$db->lastInsertId();
		 return $id;
		 
		if (!$result)
		{
			zlog(-1,$_SESSION['xmember']['username'],"xi_add_raw_job_data insert error for [{$sql}] =");
			return false;
		}

}

function xi_getUserSocialConnections($user_id,$type)
{
	$sql="
	select g.connection_id,g.connection_handle,g.connection_type,g.active
	from xconnection g 
	, xuser u 
	where u.user_id=g.created_by
	and g.connection_category = 'social' 
	and g.connection_type = '" . $type . "'
	and u.user_id=".$user_id."
	order by g.connection_type asc";
	$result=xi_getArray($sql);
	return $result;
}

//add social connection handler
function xi_addConnection($data_array)
{
/*
global $xapi_fn;
$data_array['connection_handle']=$data_array['connection_handler'];
return $xapi_fn["_Xadd_connection"]($data_array);
*/

	zlog(0,$_SESSION['xmember']['username'],"infocaptor_api.add_connection() start");
    zlog(5,$_SESSION['xmember']['username'],"infocaptor_api.add_connection data_array =".print_r($data_array,true));

	try
	{
		$now = date('Y-m-d h:i:s');
		$sql="INSERT INTO xconnection (connection_handle,connection_type,connection_category,active,creation_date,created_by,last_update_date,last_updated_by,description)
			values( '" . $data_array['connection_handler'] ."','" . $data_array['connection_type'] . "','" . $data_array['connection_category'] . "','Y','". $now ."','". xi_get_created_by()."','". $now ."','".xi_get_created_by()."','" . $data_array['connection_description'] . "')";
		
		$result=xi_getDmlResult($sql);
		if (!$result)
		{
			zlog(-1,$_SESSION['xmember']['username'],"infocaptor_api.add_connection insert error for [" . $sql. "] =");
			xi_set_message("Error adding connection..");
			return false;

		}
		$db= xi_getConnection();
		$lastId = $db->lastInsertId();
		return $lastId;
	 }
	 catch (exception $e)
	 {
		zlog(-1,$_SESSION['xmember']['username'],"infocacptor_api.add_connection SQL = [" . $sql .  "] =");
		zlog(-1,$_SESSION['xmember']['username'],"infocaptor_api.add_connection exception =".print_r($e,true));
		xi_set_message("Error adding connection..");
		return false;

	 }
	  return true;
}


function xi_getConnectionDetails($conn_id)
{
	$sql="
SELECT connection_id,connection_handle,connection_type,connection_category,active from xconnection where connection_id={$conn_id}";
	$result=xi_getArray($sql);
	return $result;
}


function xi_getPendingRawData($job_name=null,$job_user=null)
{

	
	if ($job_name=="all" || $job_name == null  )
	{
		$job_name="%";
	}

	if ($job_user=="all" || $job_user == null  )
	{
		$job_user="%";
	}
	
	$sql="
SELECT r.id raw_id,j.job_name,j.job_type,j.job_id,j.load_type,j.connection_handler,j.username,u.user_id,
case when length(j.tablestore)=0 then j.job_name
  else tablestore
end table_name,j.extrainfo1,j.extrainfo2 ,
r.raw_file_name
FROM `xjob` j
,`xjob_raw_data`  r 
, xuser u
where j.job_id=r.job_id
and j.job_name like '{$job_name}'
and j.username like '{$job_user}'
and r.load_status='pending'
and j.username=u.username
and j.job_type<>'csv_upload'
and u.active='Y'
order by r.id asc";
	$result=xi_getArray($sql);
	return $result;
}

function xi_getPendingCsvUploads()
{
	$sql="
SELECT r.id raw_id,j.job_name,j.job_type,j.job_id,j.load_type,j.connection_handler,j.username,u.user_id,
case when length(j.tablestore)=0 then 'none'
  else tablestore
end table_name,j.extrainfo1,j.extrainfo2 ,
r.raw_file_name
FROM `xjob` j
,`xjob_raw_data`  r 
, xuser u
where j.job_id=r.job_id
and r.load_status='pending'
and j.username=u.username
and j.job_type='csv_upload'
and u.active='Y'
order by r.id asc";
	$result=xi_getArray($sql);
	return $result;
}

/*
function xi_getRawDataDetails($pRawID)
{
	$sql="
SELECT r.id raw_id,j.job_name,j.job_type,j.job_id,j.load_type,j.connection_handler,j.username,u.user_id,
case when length(j.tablestore)=0 then j.job_name
  else tablestore
end table_name,j.extrainfo1,j.extrainfo2 ,
r.raw_file_name
FROM `xjob` j
,`xjob_raw_data`  r 
, xuser u
where j.job_id=r.job_id
and r.load_status='pending'
and j.username=u.username
and u.active='Y'";
	$result=xi_getArray($sql);
	return $result;
}
*/

function xi_updateRawDataStatus($pRawID,$pStatus)
{
 $sql="
	update xjob_raw_data
	set load_status='{$pStatus}'
	, last_update_date=now()
	where id={$pRawID}
	";
	xi_getDmlResult($sql);
}

function xi_initial_load_list($job_type=null,$job_name=null,$job_user=null)
{
	$sql = "SELECT * FROM xjob WHERE load_type='initial' AND load_status = 'pending'";
	if($job_type != null && $job_type!="all")
	{
		$sql .= " AND job_type like '" . $job_type . "'";
	}
	
	if ($job_name!="all" && $job_name != null  )
	{
		$sql .= " AND job_name like '" . $job_name . "'";
	}	
	if ($job_user!="all" & $job_user!="%" && $job_user != null  )
	{
		$sql .= " AND username like '" . $job_user . "'";
	}	
	
	$result=xi_getArray($sql);
	return $result;
}

function xi_incremental_load_list($job_type=null,$job_name=null)
{
	$sql = "SELECT * FROM xjob WHERE load_type='incremental' and load_status = 'pending' and end_date<=now()";
	if($job_type != null && $job_type!="all")
	{
		$sql .= " AND job_type like '" . $job_type . "'";
	}
	
	if ($job_name!="all" && $job_name != null  )
	{
		$sql .= " AND job_name like '" . $job_name . "'";
	}
	if ($job_user!="all" & $job_user!="%" && $job_user != null  )
	{
		$sql .= " AND username like '" . $job_user . "'";
	}	
	$result=xi_getArray($sql);
	return $result;
}

function xi_get_job_details($job_id)
{

	$sql = "SELECT * FROM xjob WHERE job_id=" . $job_id;
	$result=xi_getArray($sql);
	return $result;

}




function get_test_db($pwd,$db_user,$connect_owner)
{
//echo "encpwd=".$pwd."<br>";
//echo "user=".$db_user."<br>";
//echo "owner=".$connect_owner."<br>";

        $sql=<<<EOD
   SELECT
  u.user_id
, u.first_name
, u.last_name
, u.email
, u.role_id
, u.password
, u.created_by
,   u.ip_address
, u.active
        ,u.api_id
        ,r.role_name
        ,r.role_code
        ,r.level
, u.username  	
, u.description	
,date_format(u.creation_date,'%m/%d/%Y') user_start_date
,date_format(date_add(u.creation_date,INTERVAL 31 DAY),'%m/%d/%Y') user_end_date
from xuser u
,    xrole r
WHERE ( u.username='{$connect_owner}' or u.email='{$connect_owner}' )
and u.role_id = r.role_id
EOD;
	$user_info=xi_getArray($sql);
	
   
   echo "get_raw_pwd"; 
   print_r($user_info);
   
	$string=$pwd;
	$key=$db_user.substr($user_info["api_id"], 1, 11);
echo "key=".$key."<br>";
	
	 //$decrypted = rtrim(mcrypXXt_decrypt(mcrypXXt_RIJNDAEL_256, md5($key), base64_decode($string), mcrypXXt_MODE_CBC, md5(md5($key))), "\0");
	 $decrypted = xi_encrypt_decrypt("decrypt",$key, $string); 
	 return $decrypted;
}

function xi_is_license_expired($lic)
{
  zlog(2,"license","expire date = ".$lic["expire_date"]);
	$exp_dt=strtotime($lic["expire_date"]);
	$today=time();
	if (!empty($exp_dt))
	{
		zlog(2,"license","exp_dt = ".$exp_dt);	
		if ($exp_dt<$today) 
		{ 
		  zlog(2,"license","exp_dt is less than today exp_dt={$exp_dt} , today={$today}");	
			return true; //already expired
		}
		else return ;
	}	
	return true;

}

function xi_web_run_social() //flag to check license and valid social package
{
	if (xi_is_license_expired($_SESSION['xmember']["lic_details"])) return false;
	if ($_SESSION['xmember']["lic_details"]["product_name"]!="ICE_SOCIAL_DW") return false;
	
	return true;
}


function xi_getConnectionCount($category,$user_id)
{
$sql="select count(*) con_count from xconnection where connection_category like  '{$category}' and active='Y' and created_by={$user_id}";
$result=xi_getArray($sql);

return $result[0];
}

function xi_getJobCount($category,$user_id)
{
$sql="select count(*) job_count from xjob where job_type !='csv_upload' and active='Y' and username='{$user_id}'";
$result=xi_getArray($sql);
return $result[0];
}

function xi_getUserInfo($username)
{
$sql="select * from xuser u where  u.username='{$username}' or u.email='{$username}' ";
$result=xi_getArray($sql);
return $result[0];
}

/*dashboard sql for user limits and current counts
select xps.user_id,xmp.plan_code,xpd.description,
case when xpd.object_max_count <0 then 'Unlimited'
else xpd.object_max_count
end plan_limit
from xplan_subscription xps
, xmembership_plan xmp
, xmembership_plan_detail xpd
where now() between xps.start_date and xps.end_date
and xps.plan_id=xmp.plan_id
and xmp.plan_id=xpd.plan_id
and xpd.description in ('SS_CONNECTION','SS_JOB')

select count(*) from xconnection where active='Y'
and connection_category='social'

*/

function xi_canAddConnection()
{
//NEED to add SS logic
  if ($_SESSION['xmember']["lic_details"]["connect_object_count"]<=-1) return true; //-1 is unlimited
  
	$result=xi_getConnectionCount('social',xi_getUserID());
	zlog(0,xi_getUser(),"Current connection count={$result["con_count"]} , allowed = {$_SESSION['xmember']["lic_details"]["connect_object_count"]}");
	if ($result["con_count"]>=$_SESSION['xmember']["lic_details"]["connect_object_count"])
	{
	  echo "Max connection limit =".$_SESSION['xmember']["lic_details"]["connect_object_count"]."<br>";
	  zlog(-1,$_SESSION['xmember']['username'],"Max connection limit =".$_SESSION['xmember']["lic_details"]["connect_object_count"]);
		return false;
	}
	else return true;

}

function xi_canAddJob()
{
//NEED to add SS logic
  if ($_SESSION['xmember']["lic_details"]["job_object_count"]<=-1) return true;
  
	$result=xi_getJobCount('social',xi_getUser());
	zlog(0,xi_getUser(),"Current job count={$result["job_count"]} , allowed = {$_SESSION['xmember']["lic_details"]["job_object_count"]}");
	if ($result["job_count"]>=$_SESSION['xmember']["lic_details"]["job_object_count"])
	{
		echo "Max Extraction Job limit =".$_SESSION['xmember']["lic_details"]["job_object_count"]."<br>";
		zlog(-1,$_SESSION['xmember']['username'],"Max Extraction Job limit =".$_SESSION['xmember']["lic_details"]["job_object_count"]);
		return false;
	}	
	else return true;

}


function xi_get_lic() //flag to check license and valid social package
{
/*
if ($source=="social") //calling from social directory
{
	$lic_file="../license/license.php";
}	
else 	*/

$lic_file=dirname(__FILE__)."/license/license.php";


 include_once dirname(__FILE__)."/test.php";
 //include_once dirname(__FILE__)."/IIl829202";
 $xi="27xmember2010";
 
 	if (file_exists($lic_file))
		{
		
		include_once($lic_file);
		 
		}
	else 
	{
	   zlog(-1,"license","File missing {$lic_file}");
		return false;
	}
	
	
    foreach ($ax as $k => $v)
    {
		
		$decode_combo=base64_decode($v);
		$decode_v = explode(":",$decode_combo);
		
     $dk1=ic_decode($k,$xi);
     $dv1=ic_decode($decode_v[1],$xi);

      $lx[$dk1]=$dv1;

    }
    zlog(2,"license",print_r($lx,true));

	return $lx;
}



function xi_run_social($source) //flag to check license and valid social package
{
/*
if ($source=="social") //calling from social directory
{
	$lic_file="../license/license.php";
}	
else 	*/

$lic_file=dirname(__FILE__)."/license/license.php";


 include_once dirname(__FILE__)."/test.php";
 include_once dirname(__FILE__)."/IIl829202";
 
 	if (file_exists($lic_file))
		{
		
		include_once($lic_file);
		 
		}
	else 
	{
	   zlog(-1,"license","File missing {$lic_file}");
		return false;
	}
	
	
    foreach ($ax as $k => $v)
    {
		
		$decode_combo=base64_decode($v);
		$decode_v = explode(":",$decode_combo);
		
     $dk1=ic_decode($k,$xi);
     $dv1=ic_decode($decode_v[1],$xi);

      $lx[$dk1]=$dv1;

    }
    zlog(2,"license",print_r($lx,true));
	if (xi_is_license_expired($lx)) return false;
	if ($lx["product_name"]!="ICE_SOCIAL_DW")
	{
		zlog(-1,"license","Invalid product {$lx["product_name"]} - Social Features are not allowed");
		return false;
	}	
	
	return true;
}

function xi_social_license_check()
{
	if (!xi_run_social("social"))
	{
	//log
	zlog(-1,"license","License expired or invalid license");
	echo "License expired or invalid license";
	exit;
	}
}

function xi_connection_license_check()
{
	if (!xi_web_run_social()) 
	{
		zlog(-1,"license","License expired or invalid license");
	 echo "Invalid license or License Expired";
	 exit;
	}

	if (!xi_canAddConnection())
	{
		zlog(-1,"license","Your license has reached the maximum connections you can create. Please upgrade and add more connection capacity");
	 echo "Your license has reached the maximum connections you can create. Please upgrade and add more connection capacity";
	 exit;
	}
}

function xi_job_license_check()
{
	if (!xi_web_run_social()) 
	{
	 echo "Invalid license or License Expired";
	 zlog(-1,"license","License expired or invalid license");
	 exit;
	}

	if (!xi_canAddJob())
	{
		zlog(-1,"license","Your license has reached the maximum jobs you can create. Please upgrade and add more Job capacity");
	 echo "Your license has reached the maximum jobs you can create. Please upgrade and add more Job capacity";
	 exit;
	}
}
/*
function xi_etl_grant_user($user_id,$user_name,$dbname,$table_name)
{
  $sql="GRANT SELECT ON {$dbname}.{$table_name} TO {$user_name}@'localhost';"
   $result=get_dml_result($sql);
 if (!$result)
 {
    echo "Error granting table access {$table_name} to user {$user_name}";
 }
}
*/
/*
function xi_social_license_check()
{
	if (!xi_web_run_social()) 
	{
	 echo "Invalid license or License Expired";
	 exit;
	}

}
*/

function xi_getPhpPath() {
  $paths = explode(PATH_SEPARATOR, getenv('PATH'));
  foreach ($paths as $path) {
    // we need this for XAMPP (Windows)
    if (strstr($path, 'php.exe') && isset($_SERVER["WINDIR"]) && file_exists($path) && is_file($path)) {
        return $path;
    }
    else {
        $php_executable = $path . DIRECTORY_SEPARATOR . "php" . (isset($_SERVER["WINDIR"]) ? ".exe" : "");
        if (file_exists($php_executable) && is_file($php_executable)) {
           return $php_executable;
        }
    }
  }
  return FALSE; // not found
}

if(!function_exists('xi_set_message')){
	function xi_set_message($message)
	{
		$_SESSION['current_message']=$message;
	}
}
if(!function_exists('xi_get_message')){
	function xi_get_message()
	{
		return $_SESSION['current_message'];
	}
}
if(!function_exists('xi_get_created_by')){
	function xi_get_created_by()
	{
		zlog(0,$_SESSION['xmember']['username'],"infocaptor_api.xi_get_created_by() start");
		if (isset($_SESSION['xmember']['new_user_id'])) return $_SESSION['xmember']['new_user_id'];

		if (isset($_SESSION['xmember']["user_id"]))
		{
			$created_by=$_SESSION['xmember']["user_id"];
			zlog(0,$_SESSION['xmember']['username'],"infocaptor_api.xi_get_created_by() logged in : " . $created_by);
		}
		else
		{
			$created_by=0;
			zlog(-1,$_SESSION['xmember']['username'],"infocaptor_api.xi_get_created_by() not logged in.. default to: " . $created_by);
		}

		return $created_by;
	}
}

function xi_getRawJobsData($username)
{

		$sql="select * from xjob_raw_data 
		where username like '{$username}'";
	
	$rawjob_list = xi_getArray($sql);
	return $rawjob_list;

}
function xi_delete_raw_job($id)
{
	zlog(0,$_SESSION['xmember']['username'],"xmember_api.delete_raw_job() start");
    zlog(5,$_SESSION['xmember']['username'],"xmember_api.delete_raw_job id =".print_r($id,true));
	try{
	$sql="delete  from xjob_raw_data 
	where id=" . $id;
	
	$result=xi_getDmlResult($sql);
		if (!$result)
		{
			zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_raw_job insert error for [{$sql}] =");
			return false;
		}

		return true;
	}
	catch(exception $e){
		zlog(-1,$_SESSION['xmember']['username'],"xmember_api.delete_raw_job SQL = [{$sql}] =");
		 zlog(-1,$_SESSION['xmember']['username'],"xmember_api.delete_raw_job exception =".print_r($e,true));
		 return false;
	 }
  return true;

}
function xi_update_raw_job($job_data)
{
    zlog(0,$_SESSION['xmember']['username'],"xmember_api.update_raw_job() start");
    zlog(5,$_SESSION['xmember']['username'],"xmember_api.update_raw_job job_data =".print_r($job_data,true));

 try
 {
	 	unset($job_data['oper']);
		$values = "";
		$id = $job_data['id'];
		unset($job_data['id']);
		
		foreach($job_data as $field=>$value)
		{
			//$value = mysql_real_escape_string(((get_magic_quotes_gpc()) ? stripslashes($value) : $value));
			if(is_numeric($value) == "")
				$values .= "$field = '$value',";
			else
				$values .= "$field = $value,";
		}
		
		$values = substr($values,0,strLen($values)-1);
		
		$sql="update xjob_raw_data set " . $values ." where  id  = ". $id;

		$result=xi_getDmlResult($sql);
		if (!$result)
		{
			zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_raw_job insert error for [{$sql}] =");
			return false;
		}

		return true;
 }
 catch (exception $e)
 {
     zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_raw_job SQL = [{$sql}] =");
     zlog(-1,$_SESSION['xmember']['username'],"xmember_api.update_raw_job exception =".print_r($e,true));
     return false;
 }
  return true;
} //update raw job

if (! function_exists('array_column')) {
    function array_column(array $input, $columnKey, $indexKey = null) {
        $array = array();
        foreach ($input as $value) {
            if ( !array_key_exists($columnKey, $value)) {
                trigger_error("Key \"$columnKey\" does not exist in array");
                return false;
            }
            if (is_null($indexKey)) {
                $array[] = $value[$columnKey];
            }
            else {
                if ( !array_key_exists($indexKey, $value)) {
                    trigger_error("Key \"$indexKey\" does not exist in array");
                    return false;
                }
                if ( ! is_scalar($value[$indexKey])) {
                    trigger_error("Key \"$indexKey\" does not contain scalar value");
                    return false;
                }
                $array[$value[$indexKey]] = $value[$columnKey];
            }
        }
        return $array;
    }
}

function xi_send_client_message($id, $message, $progress,$url) {
    $d = array('message' => $message , 'progress' => $progress,'url'=>$url);
      
    echo "id: $id" . PHP_EOL;
    echo "data: " . json_encode($d) . PHP_EOL;
    echo PHP_EOL;
      
    ob_flush();
    flush();
}

/*new encrypter decrypter since php 7.1
*/
function xi_encrypt_decrypt($action,$key, $string) 
{
    $output = false;
    $encrypt_method = "AES-256-CBC";
    $secret_key = $key." key";
    $secret_iv = $key." iv";
    // hash
    $key = hash('sha256', $secret_key);
    
    // iv - encrypt method AES-256-CBC expects 16 bytes - else you will get a warning
    $iv = substr(hash('sha256', $secret_iv), 0, 16);
    if ( $action == 'encrypt' ) {
        $output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
        $output = base64_encode($output);
    } else if( $action == 'decrypt' ) {
        $output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
    }
    return $output;
}

?>