<?php

//BEGIN check wordpress related

//check wordpress is installed and if admin user is logged in
	include "woo_login_check.php";
	if (!wlc_ck_is_this_wordpress()) 
	{
		echo "not wordpress";
		die; //wrong script invoked. This section is valid only for wordpress
	}	
	else
	{
		if (!wlc_ck_is_admin()) 
		{
			echo "Ask yourself: Who Am I?";
			die;
		}	
	}
//END  check wordpress related 

header('Content-type: text/html; charset=utf-8'); 
// recommended to prevent caching of event data.
header('Cache-Control: no-cache'); 

set_time_limit(0);
ini_set('memory_limit', '-1');
ignore_user_abort(true);

include_once "system/property_definition.php";


include "system/general.php";
include_once "logfn.php";


include "{$property['dbconfig_location']}";

$gs["logging_enabled"]=='Y'; //force logging


$wp_prefix=$xdb_array['repository']['table_prefix'];
xlog(0,basename(__FILE__)." # ".__FUNCTION__." # Prefix:{$wp_prefix}");

$mesg_id=0; //for event messaging
$icdash_glb_get_input=filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
$icdash_glb_post_input=filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);

$mode=$icdash_glb_get_input['mode'];

xlog(0,basename(__FILE__)." # ".__FUNCTION__." # mode:{$mode}");
//session_start();
if ($mode=="woo_incremental_load")
{
	wil_load_incremental_woo_data();
}
else if ($mode=="set_job_start_date")
{
	$update_set_status=wic_set_ui_load_start();


	if (!$update_set_status)  //if error return 
	{
		xlog(-1,basename(__FILE__)." # ".__FUNCTION__." Error in set_job_start_date");
		$output_data["status"]="ERROR";
		$output_data["error_mesg"]=$_SESSION["ICDASH_MESG"];
		print json_encode($output_data);
		return;
	}	
		
	//now fetch the job details and send it back
	$update_get_status=wic_get_ui_load_details();


	if (!$update_get_status) //if error return
	{
		$output_data["status"]="ERROR";
		$output_data["error_mesg"]=$_SESSION["ICDASH_MESG"];
		print json_encode($output_data);
		return;
	}

	//if you reached this point then you should have the row details from xjob
	$output_data["status"]="SUCCESS";
	$output_data["job_details"]=$update_get_status[0];
	print json_encode($output_data);	

}
else if ($mode=="get_ui_load_details")
{
	$update_status=wic_get_ui_load_details();
	
	if (!$update_status) 
	{
		$output_data["status"]="ERROR";
		$output_data["error_mesg"]=$_SESSION["ICDASH_MESG"];
	}	
	
	$output_data["status"]="SUCCESS";
	$output_data["job_details"]=$update_status[0];
	print json_encode($output_data);	

}
else if ($mode=="run_ui_incremental_load")
{
	$time_start = microtime(true);
	
	$update_status=wic_run_ui_incremental_load();

	if (!$update_status) 
	{
		$output_data["status"]="ERROR";
		$output_data["error_mesg"]=$_SESSION["ICDASH_MESG"];
		print json_encode($output_data);
		return;
	}	
	

	$time_end = microtime(true);
	$time = $time_end - $time_start;

	$output_data["status"]="SUCCESS";
	$output_data["execution_time"]=$time;		
	$output_data["job_details"]=$update_status[0];
	print json_encode($output_data);	

}

//run_ui_incremental_load

function wil_load_incremental_woo_data()
{
	/*
	Currently this is not being used from any calls. Keep it for future reference.
	*/
	//now install the db objects
	global $mesg_id;
	xlog(0,basename(__FILE__)." # ".__FUNCTION__." # START mesg:{$mesg_id}");
	//$sql=file_get_contents("dbconfig/xmember_objects.sql");
	$start_date=$_POST["start_date"];
	$end_date  =$_POST["end_date"];
	
	xlog(0,basename(__FILE__)." # ".__FUNCTION__." # Start date:{$start_date} , End Date: {$end_date}");
	
	$cnt=0;

	include "woo_view_objects.php";
	$wcnt=0;
	xlog(0,basename(__FILE__)." # ".__FUNCTION__." # Entering loop to load data");
	$time_start = microtime(true);
	foreach ($ic_run as $k => $v)
	{
		if (!empty($ic_run[$k]) && isset($ic_run[$k]))
		{
			//echo "running {$query}<br>";
			$call_sql="call ic_woo_daily_load('{$start_date}','{$end_date}','WOO_UI_LOAD')";
			$output_data["call_sql"]=$call_sql;
			$object_installed=wic_get_resultset_sql($call_sql);
			
			//echo $ic_view[$k];
		$wcnt++;
		}
	}			
	$time_end = microtime(true);
	$time = $time_end - $time_start;

	$output_data["execution_time"]=$time;
	$output_data["status"]="SUCCESS";
	xlog(0,basename(__FILE__)." # ".__FUNCTION__." # Execution Status:".print_r($output_data,true));
	print json_encode($output_data);	
	return;	
		
}


function wic_get_database_connect()
{

global $db;
global $mesg_id;
global $property;

	if (isset($db))
    {
		xlog(0,basename(__FILE__)." # ".__FUNCTION__." # sending the old connection which is still active");		

		return $db;
	}
	xlog(0,basename(__FILE__)." # ".__FUNCTION__." # START");		

    try
    {
		$xconnection_name = "repository";
		$db_config_file = $property['dbconfig_location'];
		//$db_config_file = "dbconfig/xmember_dbconfig.php";


		if (file_exists($db_config_file) ) include($db_config_file);
		else 
		{
			//echo "could not find dbconfig/xmember_dbconfig.php ..<br>";

			xlog(-1,basename(__FILE__)." # ".__FUNCTION__."db config is missing..");
			xlog(-1,basename(__FILE__)." # ".__FUNCTION__." calling from = ".debug_backtrace()[1]['function']);
			return false;

		}

		$dbarry=$xdb_array["repository"];
		$dbarry["pass"]="scrambled";
		xlog(0,basename(__FILE__)." # ".__FUNCTION__."connection db_array".print_r($dbarry,true));

		$cnnt_str="mysql:host={$xdb_array[$xconnection_name]['host']};port={$xdb_array[$xconnection_name]['port']};dbname={$xdb_array[$xconnection_name]['name']}";
		$db = new PDO($cnnt_str, $xdb_array[$xconnection_name]['user'], $xdb_array[$xconnection_name]['pass']);
		$db->setAttribute( PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION );
		  

		return $db;
    }
    catch (exception $e)
    {
		  xlog(-1,basename(__FILE__)." # ".__FUNCTION__."get_database_connect ERROR Exception ".print_r($e,true));
		  $_SESSION["ICDASH_MESG"]=__FUNCTION__." # ".$e->getMessage();
		  return false;
    }

}



function wic_get_resultset_sql($sql)
{
    xlog(0,basename(__FILE__)." # ".__FUNCTION__." wic_get_resultset_sql() start");
    xlog(0,basename(__FILE__)." # ".__FUNCTION__." # SQL=".$sql);
 try
 {

  {
    $db= wic_get_database_connect();
	
	if ($db===FALSE) 
	{
		xlog(-1,"db handle is empty");
		return false;
	}
	
    if ($db)
    {

		$stmt = $db->prepare($sql);
		$stmt->execute();
		$count = $stmt->rowCount();
		$_SESSION["xmember"]["rows_affected"]=$count;
		xlog(0,basename(__FILE__)." # ".__FUNCTION__." # rows affected = ".$count);		
		//$recordSet = $db->Execute($sql);
	   //$_SESSION["xmember"]["rows_affected"]=$db->Affected_Rows();

      return $count+1;

    }
    else
    {
		
          xlog(-1,basename(__FILE__)." # ".__FUNCTION__." get_resultset_sql error connection".$db->errorInfo());
           xlog(-1,basename(__FILE__)." # ".__FUNCTION__." get_resultset_sql error connection".print_r($db,true));
           return false;
    }

  }
 }
 catch( exception $e)
 {
	
      xlog(-1,basename(__FILE__)." # ".__FUNCTION__." get_resultset_sql exception".print_r($e,true));
	  xlog(-1,basename(__FILE__)." # ".__FUNCTION__." get_resultset_sql Reference SQL=".$sql);
	  $_SESSION["ICDASH_MESG"]=__FUNCTION__." # ".$e->getMessage();
	  return false;
 }
}



function wic_set_ui_load_start()
{
  global $wp_prefix;
  xlog(0,basename(__FILE__)." # ".__FUNCTION__." start load from ui");
  $p_start_date=$_POST["start_date"];
  $p_increment_days=$_POST["increment_days"];
  if (empty($p_start_date))
  {
	$p_start_date=$_GET["start_date"];
	$p_increment_days=$_GET["increment_days"];

  }

  xlog(0,basename(__FILE__)." # ".__FUNCTION__." # start date : {$p_start_date} , incremental_days : {$p_increment_days}");
  $sql="update xjob set last_run_date='{$p_start_date}', incremental_duration={$p_increment_days} ,load_status='pending' where job_name='WOO_UI_LOAD'";
  $update_status=wic_get_resultset_sql($sql);   
  xlog(0," update status =".$update_status);
  if (!$update_status) return false;

  $sql="update {$wp_prefix}options set option_value='{$p_start_date}' where option_name='icdash_etl_start_date'";
  $update_status=wic_get_resultset_sql($sql);   
  if (!$update_status) return false;
  
  $sql="update {$wp_prefix}options set option_value='{$p_increment_days}' where option_name='icdash_etl_increment_days'";
  $update_status=wic_get_resultset_sql($sql);   
  if (!$update_status) return false;

  return true;
  
}

function wic_get_ui_load_details()
{
  xlog(0,basename(__FILE__)." # ".__FUNCTION__." get ui load details START");	
  $sql="select x.*,date(last_run_date) load_from_date,date(date_add(last_run_date,INTERVAL incremental_duration DAY)) load_to_date from xjob x where job_name='WOO_UI_LOAD'";
  return woo_ic_getArray($sql);
}

function wic_run_ui_incremental_load()
{
	xlog(0,basename(__FILE__)." # ".__FUNCTION__." RUN ui incremental START");			
  $sql="call ic_woo_daily_load('null','null','WOO_UI_LOAD')";
  return woo_ic_getArray($sql);
}

function woo_ic_getArray($sql)
{
	xlog(0,basename(__FILE__)." # ".__FUNCTION__." SQL : {$sql}");			
 try
 {
    $db= wic_get_database_connect();
    if ($db)
    {

		$stmt=$db->query($sql);
		if ($stmt) //if success
		{
		  
			$stmt->setFetchMode(PDO::FETCH_ASSOC);
			$rows = $stmt->fetchAll();
	
			unset($stmt);
			return $rows;
		}
		else
		{
		   unset($stmt);
		   $err=$db->errorInfo();
		   xlog(-1,basename(__FILE__)." # ".__FUNCTION__." Error running statement".$db->errorInfo());
		   $_SESSION["ICDASH_MESG"]=__FUNCTION__." # ".$db->errorInfo();
			return false;
		}	
		//$recordSet = $db->Execute($sql);
	   //$_SESSION["xmember"]["rows_affected"]=$db->Affected_Rows();

      return false;


    }
    else
        {
			xlog(-1,basename(__FILE__)." # ".__FUNCTION__." Error getting DB connection".$db->errorInfo());
			$_SESSION["ICDASH_MESG"]=__FUNCTION__." # ".$e->getMessage();
           return false;
    }

  
 }
 catch( exception $e)
 {

	xlog(-1,basename(__FILE__)." # ".__FUNCTION__." Exception".print_r($e,true));
	xlog(-1,basename(__FILE__)." # ".__FUNCTION__." Exception SQL=".$sql);
	$_SESSION["ICDASH_MESG"]=__FUNCTION__." # ".$e->getMessage();
   return false;
 }
}

function wii_send_client_message($id, $message, $progress,$url) {
    $d = array('message' => $message , 'progress' => $progress,'url'=>$url);
      
    echo "id: $id" . PHP_EOL;
    echo "data: " . json_encode($d) . PHP_EOL;
    echo PHP_EOL;
      
    ob_flush();
    flush();
}

?>