<?php

header('Content-Type: text/event-stream');
// recommended to prevent caching of event data.
header('Cache-Control: no-cache'); 

//BEGIN check wordpress related

//check wordpress is installed and if admin user is logged in
	include "woo_login_check.php";
	if (!wlc_ck_is_this_wordpress()) 
	{
		echo "not wordpress";
		die; //wrong script invoked. This section is valid only for wordpress
	}	
	else
	{
		if (!wlc_ck_is_admin()) 
		{
			echo "Ask yourself: Who Am I?";
			die;
		}	
	}
//END  check wordpress related 


set_time_limit(0);
ini_set('memory_limit', '-1');
ignore_user_abort(true);

include_once "system/property_definition.php";



//echo "stg1<br>";
include "system/general.php";
include_once "logfn.php";
//echo "stg2<br>";
$gs["logging_enabled"]=='Y'; //force logging

//echo "stg3<br>";
$mesg_id=0; //for event messaging

$icdash_glb_get_input=filter_input_array(INPUT_GET, FILTER_SANITIZE_STRING);
$icdash_glb_post_input=filter_input_array(INPUT_POST, FILTER_SANITIZE_STRING);

$mode=$icdash_glb_get_input['mode'];

if ($mode!='PLUGN_UPGRADE') exit;

$download_link=$icdash_glb_get_input['down_lnk'];
$plugin_name=$icdash_glb_get_input['plugin_dir_base'];
$content_path=$icdash_glb_get_input['content_dir'];

$temp_dir_path="{$content_path}/upgrade/{$plugin_name}.zip";
$upgrade_dir_path="{$content_path}/upgrade/";
$extract_dir="{$content_path}/upgrade/{$plugin_name}";



wiu_send_client_message('START'
				, 'Initiating download of file from server'
				,0
				,'');

icwoo_download_file($download_link, $temp_dir_path);

wiu_send_client_message($mesg_id++,$cnt." Initiating extraction of the file ",25,''); //25 percent complete

icwoo_extract_file($plugin_name,$temp_dir_path, $extract_dir);

wiu_send_client_message($mesg_id++,$cnt." Initiating upgrade ",50,''); //25 percent complete

icwoo_recursive_copy($extract_dir,"{$content_path}/plugins/{$plugin_name}");

wiu_send_client_message('CLOSE', 'Complete',100,'');


function icwoo_download_file($url, $path)
{
global $mesg_id;

    $newfname = $path;
    $file = fopen ($url, 'rb');
    if ($file) 
	{
        $newf = fopen ($newfname, 'wb');
        if ($newf) 
		{
            while(!feof($file)) {
                fwrite($newf, fread($file, 1024 * 8), 1024 * 8);
            }
        }
		else
		{
			xlog(-1,"'Cannot create file in the wp upgrade folder from {$url}");
			wiu_send_client_message('CLOSE'
				, 'Cannot save downloaded file in upgrade folder. Please check folder permissions'
				,0
				,'');
			exit;	
		
		}
    }
	else
	{
		xlog(-1,"Cannot download file from {$url}");
		wiu_send_client_message('CLOSE'
			, 'Error... Cannot download file. Please try again or perform manuall upgrade'
			,0
			,'');
		exit;	
	}
    if ($file) {
        fclose($file);
    }
    if ($newf) {
        fclose($newf);
    }
	wiu_send_client_message($mesg_id++,$cnt." Download Complete ",25,''); //25 percent complete
}


function icwoo_extract_file($plugin_name,$downloaded_file, $extract_dir)
{

 global $mesg_id;
  /* create directory if not exists', otherwise overwrite */
  /* target directory is same as filename without extension */
 
  if (is_dir($extract_dir))  icwoo_rmdir_recursive ( $extract_dir);
  mkdir($extract_dir, 0755);
  
  	if(file_exists($downloaded_file)) 
	{
		$zip = new ZipArchive();
		$x = $zip->open($downloaded_file);  // open the zip file to extract
		if ($x === true) 
		{
			$zip->extractTo($extract_dir); // place in the directory with same name  
			$zip->close();
 
			unlink($downloaded_file);
		}
		else
		{
			wiu_send_client_message('CLOSE'
			, 'Error... Cannot extract downloaded file'
			,0
			,'');		
		}
		
		wiu_send_client_message($mesg_id++,$cnt." Zip file extraction complete ",50,''); //25 percent complete
	} else 
	{	
		wiu_send_client_message('CLOSE'
			, 'Error... Cannot download or cannot locate the plugin file'
			,0
			,'');
	}
 
}

function icwoo_recursive_copy($source_dir,$dest_dir)
{
global $mesg_id;

$target_dir=$dest_dir;
wiu_send_client_message($mesg_id++,$cnt." {$source_dir} => {$target_dir} ",60,''); 
  if (file_exists("DEVENV.php")) 
  {
     include "DEVENV.php";
	 $target_dir=$work_dir;
	wiu_send_client_message($mesg_id++,$cnt."Dev environment.. {$source_dir} => {$target_dir} ",60,''); 
	 
	  xlog(-1,"Upgrade of plugin detected dev env. Cannot proceed with remaining steps");
	  		wiu_send_client_message('CLOSE'
			, 'Error... Dev environment detected. Cannot proceed'
			,0
			,'');
	  return;
  }
  else
  {
		wiu_send_client_message($mesg_id++,$cnt." Please wait... Upgrading now ",70,''); 
	 // return;
   }	

	//mkdir($dest_dir, 0755);
	foreach (
	 $iterator = new \RecursiveIteratorIterator(
	  new \RecursiveDirectoryIterator($source_dir, \RecursiveDirectoryIterator::SKIP_DOTS),
	  \RecursiveIteratorIterator::SELF_FIRST) as $item
	) 
	{
	  if ($item->isDir()) {
		mkdir($target_dir . DIRECTORY_SEPARATOR . $iterator->getSubPathName());
	  } else {
	  
		copy($item, $target_dir . DIRECTORY_SEPARATOR . $iterator->getSubPathName());
	  }
	}
	wiu_send_client_message($mesg_id++,$cnt." Upgrade Complete ",100,''); 
}

function icwoo_rmdir_recursive($dir) {
    foreach(scandir($dir) as $file) {
       if ('.' === $file || '..' === $file) continue;
       if (is_dir("$dir/$file")) icwoo_rmdir_recursive("$dir/$file");
       else unlink("$dir/$file");
   }
 
   rmdir($dir);
}

function wiu_send_client_message($id, $message, $progress,$url) {
    $d = array('message' => $message , 'progress' => $progress,'url'=>$url);
      
    echo "id: $id" . PHP_EOL;
    echo "data: " . json_encode($d) . PHP_EOL;
    echo PHP_EOL;
      
    ob_flush();
    flush();
}

?>